package com.weaver.seconddev.cockpit.cmd;

import com.weaver.ebuilder.datasource.api.entity.SqlParamEntity;
import com.weaver.ebuilder.datasource.api.enums.SqlParamType;
import com.weaver.seconddev.cockpit.util.DatabaseUtils;
import com.weaver.seconddev.cockpit.util.JucailinCockpitUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.time.LocalDate;
import java.time.Period;
import java.util.*;

/**
 * 流程、日程、协助、文档 4个类型数据
 *
 * @author shil
 * @version 1.00版本
 * @Date 2024/5/22
 */
@Component
public class CockpitUserDataCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(CockpitUserDataCmd.class);

    @Autowired
    private JucailinCockpitUtils jucailinCockpitUtils;

    @Autowired
    private DatabaseUtils databaseUtils;


    public Map<String, Object> getDataInfo(SimpleEmployee employee, Map<String, Object> paramMap, String tenantKey) {

        Map<String, Object> userMap = new HashMap<String, Object>();
        String sourceType = "LOGIC";
        String groupId ="weaver-ebuilder-form-service";

        try{

            Long deptid = 0L ;
            String subcompanynme = "";
            String employeeId = "";

            String deptname = "" ;
            String positionname = "";
            String username = "";
            try {
                employeeId = String.valueOf(employee.getEmployeeId());
                username = employee.getName();
            }catch (Exception e) {
                e.printStackTrace();
                log.error("getDataInfo1:"+e);
            }
            log.error("employeeId:" + employeeId);
            log.error("username:" + username);

            try {
                deptname = employee.getDepartment().getName();
                deptid = employee.getDepartment().getId();
            }catch (Exception e) {
                e.printStackTrace();
                log.error("getDataInfo2:"+e);
            }
            log.error("deptname:" + deptname);
            log.error("deptid:" + deptid);

            try {
                positionname = employee.getPosition().getName();
            }catch (Exception e) {
                e.printStackTrace();
                log.error("getDataInfo3:"+e);
            }
            log.error("positionname:" + positionname);

            String personnelstatusname = "正式员工";
            String personnelstatus = "";
            try {
                personnelstatus = employee.getPersonnelStatus();
                log.error("personnelstatus:" + personnelstatus);
                if ("1".equals(personnelstatus)) {
                    personnelstatusname = "试用员工";
                } else if ("2".equals(personnelstatus)) {
                    personnelstatusname = "试用延期员工";
                } else if ("3".equals(personnelstatus)) {
                    personnelstatusname = "正式员工";
                } else if ("4".equals(personnelstatus)) {
                    personnelstatusname = "临时员工";
                } else if ("5".equals(personnelstatus)) {
                    personnelstatusname = "实习员工";
                } else if ("6".equals(personnelstatus)) {
                    personnelstatusname = "离职员工";
                } else if ("7".equals(personnelstatus)) {
                    personnelstatusname = "退休员工";
                } else if ("9".equals(personnelstatus)) {
                    personnelstatusname = "解聘员工";
                } else if ("10".equals(personnelstatus)) {
                    personnelstatusname = "无效员工";
                }
            }catch (Exception e) {
                e.printStackTrace();
                log.error("getDataInfo4:"+e);
            }
            log.error("personnelstatusname:" + personnelstatusname);

            try {
                if (StringUtils.isNotBlank(deptid + "")) {
                    String sql =" select name from eteams.department where id in( " +
                            " select subcompanyid from eteams.department where id = ? and delete_type=0 and tenant_key = ?" +
                            " ) and delete_type=0 and tenant_key = ?";

                    log.error("sql:" + sql);
                    List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
                    SqlParamEntity sqlParamEntity = new SqlParamEntity();
                    sqlParamEntity.setParamType(SqlParamType.LONG);
                    sqlParamEntity.setValue(deptid + "");
                    sqlparam.add(sqlParamEntity);

                    sqlParamEntity = new SqlParamEntity();
                    sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                    sqlParamEntity.setValue(tenantKey);
                    sqlparam.add(sqlParamEntity);

                    sqlParamEntity = new SqlParamEntity();
                    sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                    sqlParamEntity.setValue(tenantKey);
                    sqlparam.add(sqlParamEntity);

                    Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql, sqlparam);
                    List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
                    if (!recordList.isEmpty() && recordList.size() > 0) {
                        subcompanynme = String.valueOf(recordList.get(0).get("name"));
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
                log.error("getDataInfo5:"+e);
            }

            String jobcallname = "";
            try{
                long jobcallid = employee.getJobCall();
                log.error("jobcallid:" + jobcallid);
                if (StringUtils.isNotBlank(jobcallid + "")) {
                    String sql =" select data_name from eteams.hrm_jobcall " +
                                " where id = ? " +
                                " and tenant_key = ? \n";
                    log.error("sql:" + sql);
                    List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
                    SqlParamEntity sqlParamEntity = new SqlParamEntity();
                    sqlParamEntity.setParamType(SqlParamType.LONG);
                    sqlParamEntity.setValue(jobcallid + "");
                    sqlparam.add(sqlParamEntity);

                    sqlParamEntity = new SqlParamEntity();
                    sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                    sqlParamEntity.setValue(tenantKey);
                    sqlparam.add(sqlParamEntity);

                    Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql, sqlparam);
                    List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
                    if (!recordList.isEmpty() && recordList.size() > 0) {
                        jobcallname = String.valueOf(recordList.get(0).get("data_name"));
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
                log.error("getDataInfo6:"+e);
            }

            String field69 = "";
            try{
                long formdata = employee.getFormdata();
                log.error("formdata:" + formdata);
                if (StringUtils.isNotBlank(formdata + "")) {

                    String pkey = "field69.groupId";
                    //weaver-ebuilder-form-service
                    String groupId2 = jucailinCockpitUtils.getUfPropData(pkey, tenantKey);
                    log.error("groupId2:" + groupId2);

                    String sql = " select field69 from eteams.Hrmemployeedefined where form_data_id = ? and tenant_key = ? ";
                    log.error("getSelfServiceData--sql:" + sql);

                    List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
                    SqlParamEntity sqlParamEntity = new SqlParamEntity();
                    sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                    sqlParamEntity.setValue(formdata + "");
                    sqlparam.add(sqlParamEntity);

                    sqlParamEntity = new SqlParamEntity();
                    sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                    sqlParamEntity.setValue(tenantKey);
                    sqlparam.add(sqlParamEntity);

                    Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId2, sql, sqlparam);
                    List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
                    if (recordList.size() > 0) {
                        field69 = String.valueOf(recordList.get(0).get("field69"));
                    }
                    if ("1".equals(field69)) {
                        field69 = "销售";
                    } else if ("2".equals(field69)) {
                        field69 = "项目";
                    } else if ("3".equals(field69)) {
                        field69 = "技术";
                    } else if ("4".equals(field69)) {
                        field69 = "客服";
                    } else if ("5".equals(field69)) {
                        field69 = "运营";
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
                log.error("getDataInfo6:"+e);
            }
            log.error("field69:" + field69);

            String avatarUrl = "";
            String hiredate = "";
            try {
                String sex = "";
                String resourceimageid = "";
                if(StringUtils.isNotBlank(employeeId)){
                    String dataSql =" select date_format(a.hiredate,'%Y-%m-%d') hiredate,resourceimageid,sex " +
                            " from eteams.employee a   " +
                            " where a.id = ?   " +
                            " and a.tenant_key = ?  " +
                            " and a.status = 'normal'   " +
                            " and a.type = 'inside'" +
                            " and delete_type = 0";

                    log.error("getEmployeeHireData--dataSql:" + dataSql);
                    List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
                    SqlParamEntity sqlParamEntity = new SqlParamEntity();
                    sqlParamEntity.setParamType(SqlParamType.LONG);
                    sqlParamEntity.setValue(employeeId + "");
                    sqlparam.add(sqlParamEntity);

                    sqlParamEntity = new SqlParamEntity();
                    sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                    sqlParamEntity.setValue(tenantKey);
                    sqlparam.add(sqlParamEntity);

                    Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, dataSql, sqlparam);
                    List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
                    if (CollectionUtils.isNotEmpty(recordList)) {
                        Map<String, Object> recordMap = recordList.get(0);
                        hiredate = String.valueOf(recordMap.get("hiredate"));
                        resourceimageid = String.valueOf(recordMap.get("resourceimageid"));
                        sex = String.valueOf(recordMap.get("sex"));
                    }
                    log.error("hiredate:"+hiredate);
                }

                if(StringUtils.isNotBlank(resourceimageid)){
                    avatarUrl = "/api/file/preview?type=redirect&fileId="+resourceimageid;
                }
                if (StringUtils.isBlank(avatarUrl)) {
                    if("male".equals(sex)){
                        avatarUrl = "/build/hrm/static/media/male.png"; //female
                    }else if("female".equals(sex)){
                        avatarUrl = "/build/hrm/static/media/female.png"; //female
                    }else{
                        avatarUrl = "/build/hrm/static/media/male.png"; //female
                    }
                }
            }catch (Exception e) {
                e.printStackTrace();
                log.error("getDataInfo7:"+e);
            }

            List<Map<String, Object>> customList = new ArrayList<Map<String, Object>>();
            try {
                customList = getCustomType(employee, tenantKey);
                userMap.put("customType", customList);
            }catch (Exception e){
                e.printStackTrace();
                log.error("getDataInfo8:"+e);
            }

            List<Map<String, Object>> changeList = new ArrayList<Map<String, Object>>();
            try {
                if (StringUtils.isNotBlank(hiredate)) {
                    Map<String, Object> hireMap = new HashMap<String, Object>();
                    hireMap.put("change_date", hiredate);
                    hireMap.put("operator_type", "entry");
                    hireMap.put("operator_type_name", "入职");
                    hireMap.put("data_type", "");
                    hireMap.put("data_value", "");
                    hireMap.put("change_id", "");
                    changeList.add(hireMap);
                }

                List<Map<String, Object>> empList = getEmpChangeData(employeeId, tenantKey);
                if(!empList.isEmpty() && empList.size()>0){
                    changeList.addAll(empList);
                }

                for (int i = 0; i < changeList.size()-1; i++) {
                    Map<String,Object> currentMap = changeList.get(i);
                    Map<String,Object> nextMap = changeList.get(i+1);
                    String current_changedate = String.valueOf(currentMap.get("change_date"));
                    String next_changedate = String.valueOf(nextMap.get("change_date"));
                    log.error("current_changedate:"+current_changedate);
                    log.error("next_changedate:"+next_changedate);

                    String diffdate = "";
                    if(StringUtils.isNotBlank(current_changedate) && StringUtils.isNotBlank(next_changedate)
                            && !"null".equals(current_changedate) && !"null".equals(next_changedate)
                    ){
                        try{
                            LocalDate current_date = LocalDate.parse(current_changedate);
                            LocalDate next_date = LocalDate.parse(next_changedate);
                            // 计算两个日期之间的期间
                            Period period = Period.between(current_date, next_date);
                            int year = period.getYears();
                            int month = period.getMonths();
                            if(year > 0){
                                diffdate = year+"年";
                            }
                            if(month > 0){
                                diffdate = diffdate +month+"月";
                            }
                        }catch (Exception e){
                            e.printStackTrace();
                            log.error("getDataInfo:"+e);
                        }
                    }
                    currentMap.put("diffdate",diffdate);
                }
            }catch (Exception e){
                e.printStackTrace();
                log.error("getDataInfo9:"+e);
            }

            String addTagUrl = "" ;
            try{
                String pkey = "cockpit.userdate.addtag";
                addTagUrl = jucailinCockpitUtils.getUfPropData(pkey, tenantKey);
                log.error("addTagUrl:" + addTagUrl);
            }catch (Exception e){

            }

            String userimageurl = "/profile/" + employeeId + "/personal";
            userMap.put("employeeId", employeeId);
            userMap.put("username", username);
            userMap.put("deptmentnnme", subcompanynme + "-" + deptname);
            userMap.put("positionname", positionname);
            userMap.put("userimageurl", userimageurl);
            userMap.put("jobcallname", jobcallname);
            userMap.put("personnelstatusname", personnelstatusname);
            userMap.put("personnelstatus", personnelstatus);
            userMap.put("field69", field69);
            userMap.put("avatarUrl", avatarUrl);
            userMap.put("changeList", changeList);
            userMap.put("addTagUrl", addTagUrl);

        }catch (Exception e){
            e.printStackTrace();
            log.error("PortalPerformanceInfoCmd :" + e);
        }
        return userMap;
    }

    /***
     *
     * @return
     */
    public List<Map<String, Object>> getCustomType(SimpleEmployee employee, String tenantKey) {

        List<Map<String, Object>> recordList = new ArrayList<Map<String, Object>>();
        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";
        Long employeeId = employee.getEmployeeId();
        try {
            String sql = " select p.bqmc,p.bqnr \n" +
                    " from(\n" +
                    "   select bqmc,bqnr " +
                    "   from uf_rcbq " +
                    "   where ry = ? \n" +
                    "   and delete_type = 0\n" +
                    "   and tenant_key = ? \n" +
                    "   order by xssx \n" +
                    "  ) p limit 4";

            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
            SqlParamEntity sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.LONG);
            sqlParamEntity.setValue(employeeId + "");
            sqlparam.add(sqlParamEntity);

            sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
            sqlParamEntity.setValue(tenantKey);
            sqlparam.add(sqlParamEntity);

            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql, sqlparam);
            recordList = databaseUtils.getDataSourceList(result);
//            if (recordList.size() < 4) {
//                for (int i = 0; i < (4 - recordList.size()); i++) {
//                    Map<String, Object> nullMap = new HashMap<String, Object>();
//                    recordList.add(nullMap);
//                }
//            }
        } catch (Exception e) {
            e.printStackTrace();
            log.error("getRightViewData:" + e);
        }
        return recordList;
    }


    public List<Map<String, Object>> getEmpChangeData(String employeeId, String tenantKey) {
        List<Map<String, Object>> changeList = new ArrayList<Map<String, Object>>();
        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";

        try {
            //入职
//            Map<String, Object> hireMap = getEmployeeHireData(employeeId, tenantKey, groupId, sourceType);
//            if (hireMap != null && hireMap.size() > 0) {
//                changeList.add(hireMap);
//            }

//            log.error("changeList:"+changeList.size());
            //变更
            List<Map<String, Object>> changeDataList = getEmployeeChangeData(employeeId, tenantKey, groupId, sourceType);
            if (CollectionUtils.isNotEmpty(changeDataList)) {
                changeList.addAll(changeDataList);
            }
//            //离职
//            Map<String,Object> departMap = getEmployeeDepartData(employeeId,tenantKey,groupId,sourceType);
//            if(departMap !=null && departMap.size()>0){
//                changeList.add(departMap);
//            }
        } catch (Exception e) {
            e.printStackTrace();
            log.error("getEmpChangeData:" + e);
        }
        return changeList;

    }


    /***
     *
     * @param employeeId
     * @param tenantKey
     * @return
     */
    public Map<String, Object> getEmployeeHireData(String employeeId, String tenantKey, String groupId, String sourceType) {
        Map<String, Object> map = new HashMap<String, Object>();
        try {
            String hiredate = "";
            String dataSql =" select date_format(a.hiredate,'%Y-%m-%d') hiredate " +
                    " from eteams.employee a   " +
                    " where a.id = ?   " +
                    " and a.tenant_key = ?  " +
                    " and a.status = 'normal'   " +
                    " and a.type = 'inside'" +
                    " and delete_type = 0";

            log.error("getEmployeeHireData--dataSql:" + dataSql);
            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
            SqlParamEntity sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.LONG);
            sqlParamEntity.setValue(employeeId + "");
            sqlparam.add(sqlParamEntity);

            sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
            sqlParamEntity.setValue(tenantKey);
            sqlparam.add(sqlParamEntity);

            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, dataSql, sqlparam);
            List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
            if (CollectionUtils.isNotEmpty(recordList)) {
                Map<String, Object> recordMap = recordList.get(0);
                hiredate = String.valueOf(recordMap.get("hiredate"));
            }
            log.error("hiredate:"+hiredate);
            if (StringUtils.isNotBlank(hiredate)) {
                map.put("change_date", hiredate);
                map.put("operator_type", "entry");
                map.put("operator_type_name", "入职");
                map.put("data_type", "");
                map.put("data_value", "");
                map.put("change_id", "");
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.error("getEmployeeHireData:" + e);
        }
        return map;
    }


//    public Map<String,Object> getEmployeeDepartData(Long employeeId,String tenantKey,String groupId,String sourceType){
//
//        Map<String,Object> map = new HashMap<String,Object>();
//        try {
//            String hiredate = "";
//            String dataSql =" select t.change_id,k.change_date,k.operator_type \n" +
//                            " from hrm_empchange_user t \n" +
//                            " inner join hrm_empchange k on k.id = t.change_id \n" +
//                            " where t.employeeid = ? \n" +
//                            " and t.delete_type = 0 \n" +
//                            " and t.tenant_key = ?  " +
//                            " and k.delete_type = 0 \n" +
//                            " and k.tenant_key = ?  " +
//                            " and k.batch_status = 2 \n" +
//                            " and k.operator_type = 'dismiss' ";
//
//            log.error("getuserIfo--dataSql:" + dataSql);
//            List<String> strlist = new ArrayList<>(100);
//            strlist.add(employeeId + "");
//            strlist.add(tenantKey);
//            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
//            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, dataSql, sqlparam);
//            List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
//            if (CollectionUtils.isNotEmpty(recordList)) {
//                Map<String, Object> recordMap = recordList.get(0);
//                change_date = CommonUtils.null2String(recordMap.get("change_date"));
//            }
//
//            if (StringUtils.isNotBlank(hiredate)) {
//                map.put("change_date", hiredate);
//                map.put("operator_type", "entry");
//                map.put("operator_type_name", "入职");
//                map.put("data_type", "");
//                map.put("data_value", "");
//                map.put("change_id", "");
//            }
//        }catch (Exception e){
//            e.printStackTrace();
//            log.error("getEmployeeHireData:"+e);
//        }
//        return map;
//
//    }

    /***
     *
     * @param employeeId
     * @param tenantKey
     * @param groupId
     * @param sourceType
     * @return
     */
    public List<Map<String, Object>> getEmployeeChangeData(String employeeId, String tenantKey, String groupId, String sourceType) {
        List<Map<String, Object>> recordList = new ArrayList<Map<String, Object>>();
        try {
            String dataSql =" select t.change_id,date_format(k.change_date,'%Y-%m-%d') change_date,k.operator_type,p.data_type,p.data_value \n" +
                    " from eteams.hrm_empchange_user t\n" +
                    " inner join eteams.hrm_empchange k on k.id = t.change_id\n" +
                    " inner join eteams.hrm_empchange_userdetail p on p.change_id = t.change_id\n" +
                    " where t.employeeid = ? \n" +
                    " and length(p.data_value)>0 \n" +
                    " and k.batch_status = 2 \n" +
                    " and t.delete_type = 0 \n" +
                    " and t.tenant_key = ? \n" +
                    " and p.delete_type = 0 \n" +
                    " and p.tenant_key = ? \n" +
                    " and k.delete_type = 0 \n" +
                    " and k.tenant_key = ? " +
                    " and p.data_type in('newDepartment','newPosition','newSuperior','changeStatus') \n " +
                    " order by k.change_date \n";

            log.error("getEmployeeChangeData--dataSql:" + dataSql);

            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
            SqlParamEntity sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.LONG);
            sqlParamEntity.setValue(employeeId);
            sqlparam.add(sqlParamEntity);

            sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
            sqlParamEntity.setValue(tenantKey);
            sqlparam.add(sqlParamEntity);

            sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
            sqlParamEntity.setValue(tenantKey);
            sqlparam.add(sqlParamEntity);

            sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
            sqlParamEntity.setValue(tenantKey);
            sqlparam.add(sqlParamEntity);

            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, dataSql, sqlparam);
            recordList = databaseUtils.getDataSourceList(result);
            log.error("recordList2:"+recordList.size());

            if (CollectionUtils.isNotEmpty(recordList)) {
                for (int i = 0; i < recordList.size(); i++) {
                    Map<String, Object> recordMap = recordList.get(i);
                    String operator_type = String.valueOf(recordMap.get("operator_type"));
                    log.error("operator_type:"+operator_type);
                    String data_type = String.valueOf(recordMap.get("data_type"));
                    log.error("data_type:"+data_type);
                    String data_value = String.valueOf(recordMap.get("data_value"));
                    log.error("data_value:"+data_value);

                    String operator_type_name = "";
                    String data_type_name = "";
                    String data_value_name = "";

                    if ("trial".equals(operator_type)) {
                        operator_type_name = "试用";
                    } else if ("hire".equals(operator_type)) {
                        operator_type_name = "转正";
                    } else if ("extend".equals(operator_type)) {
                        operator_type_name = "续签";
                    } else if ("redeploy".equals(operator_type)) {
                        operator_type_name = "调动";
                    } else if ("dismiss".equals(operator_type)) {
                        operator_type_name = "离职";
                    } else if ("retire".equals(operator_type)) {
                        operator_type_name = "退休";
                    } else if ("quit".equals(operator_type)) {
                        operator_type_name = "解聘";
                    } else if ("rehire".equals(operator_type)) {
                        operator_type_name = "返聘";
                    } else if ("custom".equals(operator_type)) {
                        operator_type_name = "变更";
                    }

                    if ("newDepartment".equals(data_type)) {
                        data_type_name = "部门";
                        data_value_name = getDepartmentName(data_value,tenantKey,sourceType,groupId);
                    } else if ("newPosition".equals(data_type)) {
                        data_type_name = "岗位";
                        data_value_name = getPositionName(data_value,tenantKey,sourceType,groupId);
                    } else if ("newSuperior".equals(data_type)) {
                        data_type_name = "上级";
                        data_value_name = getSuperiorName(data_value,tenantKey,sourceType,groupId);
                    }

                    recordMap.put("operator_type_name", operator_type_name);
                    recordMap.put("data_type_name", data_type_name);
                    recordMap.put("data_value_name", data_value_name);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.error("getEmpChangeData:" + e);
        }
        return recordList;
    }

    /***
     *
     * @param departmentid
     * @param tenantKey
     * @param sourceType
     * @param groupId
     * @return
     */
    public String getDepartmentName(String departmentid,String tenantKey,String sourceType,String groupId){
//        select name from Department where id=9080991104676336702
        String deptname = "" ;

        log.error("getDepartmentName--departmentid:" + departmentid);
        log.error("getDepartmentName--sourceType:" + sourceType);
        log.error("getDepartmentName--groupId:" + groupId);

        try{
            String dataSql =" select name from eteams.department where id= ? and tenant_key = ? ";
            log.error("getDepartmentName--dataSql:" + dataSql);
            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
            SqlParamEntity sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.LONG);
            sqlParamEntity.setValue(departmentid + "");
            sqlparam.add(sqlParamEntity);

            sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
            sqlParamEntity.setValue(tenantKey);
            sqlparam.add(sqlParamEntity);

            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, dataSql, sqlparam);
            List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
            log.error("getDepartmentName--recordList:" + recordList.size());
            if(!recordList.isEmpty() && recordList.size()>0){
                deptname = String.valueOf(recordList.get(0).get("name"));
            }
            log.error("getDepartmentName--deptname:" + deptname);
        }catch (Exception e){
            e.printStackTrace();
            log.error("getDepartmentName:"+e);
        }
        return deptname;
    }

    /***
     *
     * @param positionid
     * @param tenantKey
     * @param sourceType
     * @param groupId
     * @return
     */
    public String getPositionName(String positionid,String tenantKey,String sourceType,String groupId){
//        select name from Department where id=9080991104676336702
        String positionName = "" ;

        log.error("getPositionName--positionid:" + positionid);
        log.error("getPositionName--sourceType:" + sourceType);
        log.error("getPositionName--groupId:" + groupId);

        try{
            String dataSql =" select name from eteams.position where id= ? and tenant_key = ? ";
            log.error("getPositionName--dataSql:" + dataSql);
            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
            SqlParamEntity sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.LONG);
            sqlParamEntity.setValue(positionid);
            sqlparam.add(sqlParamEntity);

            sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
            sqlParamEntity.setValue(tenantKey);
            sqlparam.add(sqlParamEntity);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, dataSql, sqlparam);
            List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
            log.error("getPositionName--recordList:" + recordList.size());

            if(!recordList.isEmpty() && recordList.size()>0){
                positionName = String.valueOf(recordList.get(0).get("name"));
            }
            log.error("getPositionName--positionName:" + positionName);
        }catch (Exception e){
            e.printStackTrace();
            log.error("getPositionName:"+e);
        }
        return positionName;
    }


    /**
     *
     * @param employeeid
     * @param tenantKey
     * @param sourceType
     * @param groupId
     * @return
     */
    public String getSuperiorName(String employeeid,String tenantKey,String sourceType,String groupId){
//        select name from Department where id=9080991104676336702
        String employeeName = "" ;
        try{
            log.error("getSuperiorName--employeeid:" + employeeid);
            log.error("getSuperiorName--sourceType:" + sourceType);
            log.error("getSuperiorName--groupId:" + groupId);

            String dataSql =" select username from eteams.employee where id= ? and tenant_key = ? ";
            log.error("getSuperiorName--dataSql:" + dataSql);
            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
            SqlParamEntity sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.LONG);
            sqlParamEntity.setValue(employeeid);
            sqlparam.add(sqlParamEntity);

            sqlParamEntity = new SqlParamEntity();
            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
            sqlParamEntity.setValue(tenantKey);
            sqlparam.add(sqlParamEntity);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, dataSql, sqlparam);
            List<Map<String, Object>> recordList = databaseUtils.getDataSourceList(result);
            log.error("getSuperiorName--recordList:" + recordList.size());
            if(!recordList.isEmpty() && recordList.size()>0){
                employeeName = String.valueOf(recordList.get(0).get("username"));
            }
            log.error("getSuperiorName--employeeName:" + employeeName);
        }catch (Exception e){
            e.printStackTrace();
            log.error("getPositionName:"+e);
        }
        return employeeName;
    }



}
