package com.weaver.seconddev.cockpit.controller;

import com.weaver.common.authority.annotation.WeaPermission;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.seconddev.cockpit.service.JucailinCockpitService;
import com.weaver.seconddev.cockpit.util.JucailinCockpitUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import javax.servlet.http.HttpServletRequest;
import java.util.*;


@RestController
@RequestMapping("/api/secondev/njjucailin/cockpit")
public class JucailinCockpitController {

    private final Logger log = LoggerFactory.getLogger(JucailinCockpitController.class);

    public String tenant_key = "t7akvdnf84" ;

    @Autowired
    private JucailinCockpitService jucailinCockpitService;

    @Autowired
    private JucailinCockpitUtils jucailinCockpitUtils;


    /**
     *  绩效信息
     * @param request
     * @return
     */
    @GetMapping("/getMonthPerformanceData")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getMonthPerformanceData(HttpServletRequest request){

        Map<String, Object> recordMap = new HashMap<String, Object>();
        Map<String,Object> params = jucailinCockpitUtils.request2Map(request);
        SimpleEmployee simpleEmployee = UserContext.getCurrentUser();

        try{
            recordMap = jucailinCockpitService.getMonthPerformanceData(simpleEmployee,params,tenant_key);
        }catch (Exception e){
            log.error("testSapi-Exception:"+e);
        }

        return WeaResult.success(recordMap);
    }


    /**
     * 工作数据接口（根据职能分类返回不同数据）
     * @param request
     * @return
     */
    @GetMapping("/getWorkAchievementsData")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getWorkAchievementsData(HttpServletRequest request){
        log.error("getWorkData");
        Map<String, Object> dataList = new HashMap<String, Object>();
        SimpleEmployee simpleEmployee = UserContext.getCurrentUser();
        Map<String,Object> params = jucailinCockpitUtils.request2Map(request);

        try{
            dataList = jucailinCockpitService.getWorkAchievementsData(simpleEmployee,params,tenant_key);
        }catch (Exception e){
            log.error("getWorkData-Exception:"+e.getMessage());
        }
        return WeaResult.success(dataList);
    }


    @GetMapping("/getUserData4Type")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getUserData4Type(HttpServletRequest request){
        log.error("getUserData4Type");
        Map<String, Object> dataList = new HashMap<String, Object>();
        SimpleEmployee simpleEmployee = UserContext.getCurrentUser();
        Map<String,Object> params = jucailinCockpitUtils.request2Map(request);

        try{
            dataList = jucailinCockpitService.getUserData4Type(simpleEmployee,params,tenant_key);
        }catch (Exception e){
            log.error("getWorkData-Exception:"+e.getMessage());
        }
        return WeaResult.success(dataList);
    }



    @GetMapping("/getWorkflowAnalysis")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getWorkflowAnalysis(HttpServletRequest request){
        log.error("getWorkflowAnalysis");
        Map<String, Object> dataList = new HashMap<String, Object>();
        SimpleEmployee simpleEmployee = UserContext.getCurrentUser();
        Map<String,Object> params = jucailinCockpitUtils.request2Map(request);

        try{
            dataList = jucailinCockpitService.getWorkflowAnalysis(simpleEmployee,params,tenant_key);
        }catch (Exception e){
            log.error("getWorkData-Exception:"+e.getMessage());
        }
        return WeaResult.success(dataList);
    }


    @GetMapping("/getDocmentAnalysis")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getDocmentAnalysis(HttpServletRequest request){
        log.error("getDocmentAnalysis");
        Map<String, Object> dataList = new HashMap<String, Object>();
        SimpleEmployee simpleEmployee = UserContext.getCurrentUser();
        Map<String,Object> params = jucailinCockpitUtils.request2Map(request);

        try{
            dataList = jucailinCockpitService.getDocmentAnalysis(simpleEmployee,params,tenant_key);
        }catch (Exception e){
            log.error("getWorkData-Exception:"+e.getMessage());
        }
        return WeaResult.success(dataList);
    }


    @GetMapping("/getUserInfo")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getUserData(HttpServletRequest request){
        log.error("getWorkData");
        Map<String, Object> dataList = new HashMap<String, Object>();
        SimpleEmployee simpleEmployee = UserContext.getCurrentUser();
        Map<String,Object> params = jucailinCockpitUtils.request2Map(request);

        try{
            dataList = jucailinCockpitService.getUserInfo(simpleEmployee,params,tenant_key);
        }catch (Exception e){
            log.error("getWorkData-Exception:"+e.getMessage());
        }
        return WeaResult.success(dataList);
    }


    /***
     *
     * @param request
     * @return
     */
    @GetMapping("/getUserData3Type")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getUserData3Type(HttpServletRequest request){
        log.error("getWorkData");
        Map<String, Object> dataList = new HashMap<String, Object>();
        SimpleEmployee simpleEmployee = UserContext.getCurrentUser();
        Map<String,Object> params = jucailinCockpitUtils.request2Map(request);

        try{
            dataList = jucailinCockpitService.getUserData3Type(simpleEmployee,params,tenant_key);
        }catch (Exception e){
            log.error("getWorkData-Exception:"+e.getMessage());
        }
        return WeaResult.success(dataList);
    }


    @GetMapping("/getProjectData")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getProjectData(HttpServletRequest request){
        log.error("getWorkData");
        Map<String, Object> dataList = new HashMap<String, Object>();
        SimpleEmployee simpleEmployee = UserContext.getCurrentUser();
        Map<String,Object> params = jucailinCockpitUtils.request2Map(request);

        try{
            dataList = jucailinCockpitService.getProjectData(simpleEmployee,params,tenant_key);
        }catch (Exception e){
            log.error("getWorkData-Exception:"+e.getMessage());
        }
        return WeaResult.success(dataList);
    }

    @GetMapping("/getBlogData")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> getBlogData(HttpServletRequest request){
        log.error("getWorkData");
        Map<String, Object> dataList = new HashMap<String, Object>();
        SimpleEmployee simpleEmployee = UserContext.getCurrentUser();
        Map<String,Object> params = jucailinCockpitUtils.request2Map(request);

        try{
            dataList = jucailinCockpitService.getBlogData(simpleEmployee,params,tenant_key);
        }catch (Exception e){
            log.error("getWorkData-Exception:"+e.getMessage());
        }
        return WeaResult.success(dataList);
    }

}
