package com.weaver.seconddev.cockpit.service.impl;

import com.weaver.seconddev.cockpit.cmd.*;
import com.weaver.seconddev.cockpit.service.JucailinCockpitService;
import com.weaver.teams.domain.user.SimpleEmployee;
import groovy.util.logging.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.*;

@Slf4j
@Service
public class JucailinCockpitServiceimpl implements JucailinCockpitService {
    @Autowired
    private CockpitMonthPerformanceInfoCmd cockpitMonthPerformanceInfoCmd;

    @Autowired
    private CockpitWorkAchievementsCmd cockpitWorkAchievementsCmd;

    @Autowired
    private CockpitWorkDate4TypeCmd cockpitWorkDate4TypeCmd;

    @Autowired
    private CockpitDocumentAnalysisCmd cockpitDocumentAnalysisCmd;

    @Autowired
    private CockpitWorkflowAnalysisCmd cockpitWorkflowAnalysisCmd;

    @Autowired
    private CockpitUserDataCmd cockpitUserDataCmd;

    @Autowired
    private CockpitBlogDataCmd cockpitBlogDataCmd;

    @Autowired
    private CockpitWorkDate3TypeCmd cockpitWorkDate3TypeCmd;

    @Autowired
    private CockpitProjectDataCmd cockpitProjectDataCmd;



    @Override
    public Map<String, Object> getMonthPerformanceData(SimpleEmployee simpleEmployee, Map<String, Object> paramMap,String tenantKey) {

        Map<String,Object> dataMap = cockpitMonthPerformanceInfoCmd.getDataInfo(simpleEmployee,paramMap,tenantKey);
        return dataMap;
    }

    @Override
    public Map<String, Object> getWorkAchievementsData(SimpleEmployee simpleEmployee, Map<String, Object> paramMap, String tenantKey) {
        Map<String,Object> dataMap = cockpitWorkAchievementsCmd.getDataInfo(simpleEmployee,paramMap,tenantKey);
        return dataMap;
    }

    @Override
    public Map<String, Object> getUserData4Type(SimpleEmployee simpleEmployee, Map<String, Object> paramMap, String tenantKey) {
        Map<String,Object> dataMap = cockpitWorkDate4TypeCmd.getDataInfo(simpleEmployee,paramMap,tenantKey);
        return dataMap;
    }

    @Override
    public Map<String, Object> getWorkflowAnalysis(SimpleEmployee simpleEmployee, Map<String, Object> paramMap, String tenantKey) {
        Map<String,Object> dataMap = cockpitWorkflowAnalysisCmd.getDataInfo(simpleEmployee,paramMap,tenantKey);
        return dataMap;
    }


    @Override
    public Map<String, Object> getDocmentAnalysis(SimpleEmployee simpleEmployee, Map<String, Object> paramMap, String tenantKey) {
        Map<String,Object> dataMap = cockpitDocumentAnalysisCmd.getDataInfo(simpleEmployee,paramMap,tenantKey);
        return dataMap;
    }

    @Override
    public Map<String, Object> getUserInfo(SimpleEmployee simpleEmployee, Map<String, Object> paramMap, String tenantKey) {
        Map<String,Object> dataMap = cockpitUserDataCmd.getDataInfo(simpleEmployee,paramMap,tenantKey);
        return dataMap;
    }

    @Override
    public Map<String, Object> getUserData3Type(SimpleEmployee simpleEmployee, Map<String, Object> paramMap, String tenantKey) {
        Map<String,Object> dataMap = cockpitWorkDate3TypeCmd.getDataInfo(simpleEmployee,paramMap,tenantKey);
        return dataMap;
    }

    @Override
    public Map<String, Object> getProjectData(SimpleEmployee simpleEmployee, Map<String, Object> paramMap, String tenantKey) {
        Map<String,Object> dataMap = cockpitProjectDataCmd.getDataInfo(simpleEmployee,paramMap,tenantKey);
        return dataMap;
    }


    @Override
    public Map<String, Object> getBlogData(SimpleEmployee simpleEmployee, Map<String, Object> paramMap, String tenantKey) {
        Map<String,Object> dataMap = cockpitBlogDataCmd.getDataInfo(simpleEmployee,paramMap,tenantKey);
        return dataMap;
    }

}
