package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.ebuilder.datasource.api.entity.SqlParamEntity;
import com.weaver.ebuilder.form.client.entity.data.EBDataReqDetailDto;
import com.weaver.ebuilder.form.client.entity.data.EBDataReqDto;
import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.seconddev.jcldoor.util.JucailinPortalUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.util.*;

/**
 * 自助服务入口
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/19
 */
@Component
public class SelfServiceInfoCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(SelfServiceInfoCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    @Autowired
    private JucailinPortalUtils jucailinPortalUtils;

    public String tenant_key = "t7akvdnf84";

    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> recordMap = new HashMap<String,Object>();
        String pkey = "uf_zzfwcsh.taby.fieldId";
        String field_id =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwcsh.taby.url";
        String taburl =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";

        String employeeId = request.getParameter("employeeId");
        //type: 0 系统默认 ，1 自定义配置
        String type = "0";

        if(StringUtils.isBlank(employeeId)){
            employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
        }

        //返回自助服务tab信息
        List<Map<String,Object>> dataList  = new ArrayList<Map<String,Object>>();

        //返回近期访问数据
        List<Map<String,Object>> record  = new ArrayList<Map<String,Object>>();

        try{
            String sql = " select distinct taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and delete_type=0 and tenant_key =?";
            log.error("sql:"+sql);
            List<String> strlist = new ArrayList<>(100);
            strlist.add(employeeId);
            strlist.add(tenant_key);
            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);

            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                // /api/file/preview?type=redirect&imgFormat=small&fileId=977697615197618177&module=ebuilderform&authModule=ebuilderform&source=form&fieldId=977686869110833154&customParam=%7B%22dataId%22%3A%22977697666574729218%22%7D&refId=977697666574729218&folderId=8120831157448215424
                dataList = getCustomeServiceData(groupId,sourceType,employeeId);
                record = getCustomeServiceRecord(groupId,sourceType,employeeId);
                type = "1";
            }else{
                dataList = getDefaultServiceData(groupId,sourceType,field_id);
                record = getDefaultServiceRecord(groupId,sourceType,employeeId);
                type = "0";
            }
        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
        }
        recordMap.put("list",dataList);
        recordMap.put("record",record);
        recordMap.put("type",type);
        recordMap.put("taburl",taburl);
        return recordMap;
    }

    public List<Map<String,Object>> getCustomeServiceData(String groupId,String sourceType,String employeeId){
        List<Map<String,Object>> dataList = new ArrayList<Map<String,Object>>();

        Map<String,String> optionMap = new HashMap<String,String>();

        List<String> tbyList = new ArrayList<String>();
        try{
            String sql = " select id,tabymmc from uf_zzfwrktaby where qy is not null and ry=? and delete_type=0 and tenant_key = ? order by ifnull(xssx,0) ";
            log.error("getCustomServiceTypeName-sql:"+sql);
            List<String> strlist = new ArrayList<>(100);
            strlist.add(employeeId);
            strlist.add(tenant_key);
            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String value = String.valueOf(recordMap.get("id"));
                String name = String.valueOf(recordMap.get("tabymmc"));
                log.error("getCustomServiceTypeName-value:"+value+" name:"+name);
                optionMap.put(value,name);
                tbyList.add(value);
            }

            log.error("getCustemSelfServiceType-tbyList:"+tbyList.size());

            for(int i=0;i<tbyList.size();i++){
                Map<String,Object> recordMap = new HashMap<String,Object>();
                String taby = String.valueOf(tbyList.get(i));
                log.error("getCustemSelfServiceType-taby:"+taby);
                recordMap.put("taby",taby);
                String tabyName = optionMap.get(taby);
                List<Map<String,Object>> customList = getCustomeServiceDataByType(groupId,sourceType,taby,employeeId);
                log.error("getCustemSelfServiceType-tabyName:"+tabyName);
                recordMap.put("menus",customList);
                recordMap.put("name",tabyName);
                dataList.add(recordMap);
            }
        }catch (Exception e){
            log.error("getCustomServiceTypeName-e:"+e);
        }
        log.error("getCustemSelfServiceType-dataList:"+dataList.size());
        return dataList;
    }

    public List<Map<String,Object>> getCustomeServiceDataByType(String groupId,String sourceType,String value,String employeeId){

        List<Map<String,Object>> dataList = new ArrayList<Map<String,Object>>();
        try{
            String sql = " select id,fwmc,fwdz,fwtb,taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and taby=? and delete_type=0 and tenant_key = ? order by ifnull(xssx,0) ";
            log.error("getSelfServiceData--sql:"+sql);
            List<String> strlist = new ArrayList<>(100);
            strlist.add(employeeId);
            strlist.add(value);
            strlist.add(tenant_key);
            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String fwtb = String.valueOf(recordMap.get("fwtb"));
                String fwtburl = "";
                if(StringUtils.isNotBlank(fwtb)){
                    fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
                }
                recordMap.put("fwtburl",fwtburl);

                dataList.add(recordMap);
            }
        }catch (Exception e){
            e.printStackTrace();
            log.error("getCustomeServiceDataByType-e:"+e);
        }
        return dataList;
    }

    /***
     *  默认数据
     * @param groupId
     * @param sourceType
     * @return
     */
    public List<Map<String,Object>> getDefaultServiceData(String groupId,String sourceType,String field_id){
        List<Map<String,Object>> dataList = new ArrayList<Map<String,Object>>();
        try{
            String sql = " select name,value_key as taby from field_option where field_id=? and  delete_type=0 and tenant_key = ?";
            log.info("sql:"+sql);

            List<String> strlist = new ArrayList<>(100);
            strlist.add(field_id);
            strlist.add(tenant_key);

            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String taby = String.valueOf(recordMap.get("taby"));
                List<Map<String,Object>> defaultList =  getDefaultServiceDataByType(groupId,sourceType,taby);
                recordMap.put("menus",defaultList);

                dataList.add(recordMap);
            }
        }catch (Exception e){
            e.printStackTrace();
            log.error("getDefaultServiceData-e:"+e);
        }

        return dataList;
    }

    /***
     * 默认数据
     * @param groupId
     * @param sourceType
     * @param value
     * @return
     */
    public List<Map<String,Object>> getDefaultServiceDataByType(String groupId,String sourceType,String value){

        List<Map<String,Object>> dataList = new ArrayList<Map<String,Object>>();
        try{
            String sql =" select t.taby,t.fwtb,t.fwmc,t.fwdz " +
                    " from uf_zzfwcsh t \n" +
                    " where t.delete_type=0 \n" +
                    " and t.taby= ?" +
                    " and t.tenant_key = ?" +
                    " order by ifnull(t.xssx,0) ";

            log.error("getSelfServiceData--sql:"+sql);

            List<String> strlist = new ArrayList<>(100);
            strlist.add(value);
            strlist.add(tenant_key);

            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String fwtb = String.valueOf(recordMap.get("fwtb"));
                String fwtburl = "";
                if(StringUtils.isNotBlank(fwtb)){
                    fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
                }
                recordMap.put("fwtburl",fwtburl);

                dataList.add(recordMap);
            }
        }catch (Exception e){
            e.printStackTrace();
            log.error("getDefaultServiceDataByType-e:"+e);
        }

        return dataList;
    }

    /***
     *
     * @param groupId
     * @param sourceType
     * @return
     */
    public Map<String,String> getCustomServiceTypeName(String groupId,String sourceType,String employeeId){

        Map<String,String> optionMap = new HashMap<String,String>();

        try{
            String sql = " select id,tabymmc from uf_zzfwrktaby where qy is not null and ry=? and delete_type=0 and tenant_key = ? order by ifnull(xssx,0) ";
            log.error("getCustomServiceTypeName-sql:"+sql);
            List<String> strlist = new ArrayList<>(100);
            strlist.add(employeeId);
            strlist.add(tenant_key);
            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String value = String.valueOf(recordMap.get("id"));
                String name = String.valueOf(recordMap.get("tabymmc"));
                log.error("getCustomServiceTypeName-value:"+value+" name:"+name);
                optionMap.put(value,name);
            }
        }catch (Exception e){
            log.error("getCustomServiceTypeName-e:"+e);
        }
        return optionMap;
    }


    /**
     * 近期访问数据（自定义配置时）
     * @param groupId
     * @param sourceType
     * @param employeeId
     * @return
     */
    public List<Map<String,Object>> getCustomeServiceRecord(String groupId,String sourceType,String employeeId){

        List<Map<String,Object>> dataList = new ArrayList<Map<String,Object>>();
        try {
            String sql = " select id,fwmc,fwdz,fwtb,taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and delete_type=0 and tenant_key = ? order by djcs desc limit 6";
            log.info("getCustomeServiceRecord--sql:"+sql);

            List<String> strlist = new ArrayList<>(100);
            strlist.add(employeeId);
            strlist.add(tenant_key);

            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String fwtb = String.valueOf(recordMap.get("fwtb"));
                String fwtburl = "";
                if(StringUtils.isNotBlank(fwtb)){
                    fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
                }
                recordMap.put("fwtburl",fwtburl);

                dataList.add(recordMap);
            }
        }catch (Exception e){
            e.printStackTrace();
            log.error("getCustomeServiceRecord-e:"+e);
        }
        return dataList;
    }

    /**
     * 新增点击次数
     * @param request
     * @param simpleEmployee
     * @return
     */
    public Map<String, Object> addSelfServiceCount(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> recordMap = new HashMap<String,Object>();
        String id = request.getParameter("id");
        if(StringUtils.isBlank(id)){
            recordMap.put("status",false);
        }else {
            String groupId = "weaver-ebuilder-form-service";
            String sourceType = "LOGIC";
            String sql = "update uf_zzfwrkpz set djcs = ifnull(djcs,0) + 1 where id = ?";

            List<String> strlist = new ArrayList<>(100);
            strlist.add(id);

            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            recordMap.put("status",true);
        }
        return recordMap;
    }

    /**
     * 默认类型 经常访问数据
     * @param groupId
     * @param sourceType
     * @param employeeId
     * @return
     */
    public List<Map<String,Object>> getDefaultServiceRecord(String groupId,String sourceType,String employeeId){
        String sql = "select t.taby,t.fwtb,t.fwmc,t.fwdz from uf_zzfwcsh t where t.delete_type=0 and t.tenant_key = ? limit 6";
        log.info("getDefaultServiceRecord--sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        return recordList;
    }


    /***
     *
     * @param paramMap
     * @return
     */
    public Map<String,Object> initSelfServiceData(Map<String,Object> paramMap){

        String employeeId = String.valueOf(paramMap.get("employeeId"));
        log.error("employeeId:"+employeeId);

        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";

        Map<String,Object> recordMap = new HashMap<String,Object>();
        String pkey = "uf_zzfwcsh.taby.fieldId";
        String field_id =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwrktaby.qy.value";
        String uf_zzfwrktaby_qy =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwrkpz.qy.value";
        String uf_zzfwrkpz_qy =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        try{
            String sql = " select distinct taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and delete_type=0 and tenant_key =?";

            List<String> strlist = new ArrayList<>(100);
            strlist.add(employeeId);
            strlist.add(tenant_key);
            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                recordMap.put("code","200");
                recordMap.put("type","1");
            }else{
                log.error("uf_zzfwrkpz is null ");
                int count = initCustomServiceData(groupId,sourceType,field_id,employeeId,uf_zzfwrktaby_qy,uf_zzfwrkpz_qy);
                if(count > 0){
                    recordMap.put("code","-100");
                }else{
                    recordMap.put("code","200");
                }
                recordMap.put("type","0");
            }
        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
            recordMap.put("code","-200");
        }

        return recordMap;
    }


    /***
     *  默认数据
     * @param groupId
     * @param sourceType
     * @return
     */
    public int initCustomServiceData(String groupId,String sourceType,String field_id,String employeeId,String uf_zzfwrktaby_qy,String uf_zzfwrkpz_qy){
        int errcount = 0;
        try{
            List<Map<String,Object>> recordList = getFieldOptionList(sourceType,groupId,field_id);
            log.error("initCustomServiceData-recordList:"+recordList.size());
            updateServiceTabData(employeeId,sourceType,groupId,uf_zzfwrktaby_qy,recordList);

            for(int i=0;i<recordList.size();i++) {
                Map<String, Object> recordMap = recordList.get(i);
                String name = String.valueOf(recordMap.get("name"));
                String taby = String.valueOf(recordMap.get("taby"));

                String tabid = getServiceTabId(employeeId, name, groupId, sourceType, uf_zzfwrktaby_qy,"1");
                log.error("initCustomServiceData-tabid:"+tabid);

                if(StringUtils.isNotBlank(tabid)){
                    initCustomServiceDataByType(employeeId,groupId,sourceType,taby,tabid,uf_zzfwrkpz_qy);
                }
            }
        }catch (Exception e){
            errcount++;
            e.printStackTrace();
            log.error("Exception-e:"+e);
        }
        return errcount;
    }

    /***
     *
     * @param sourceType
     * @param groupId
     * @param field_id
     * @return
     */
    public List<Map<String,Object>> getFieldOptionList(String sourceType,String groupId,String field_id){
        List<Map<String,Object>> recordList = new ArrayList<Map<String,Object>>();

        try{
            String sql = " select name,value_key as taby from field_option where field_id=? and delete_type=0 and tenant_key = ?";
            log.error("sql:"+sql);
            List<String> paramList = new ArrayList<>(100);
            paramList.add(field_id);
            paramList.add(tenant_key);

            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(paramList);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            recordList = databaseUtils.getDataSourceList(result);

        }catch (Exception e){
            log.error("getFieldOptionList-e:"+e);
        }
        return recordList;
    }

    /***
     *
     * @param employeeId
     * @param sourceType
     * @param groupId
     * @param recordList
     * @return
     */
    public String updateServiceTabData(String employeeId,String sourceType,String groupId,String uf_zzfwrktaby_qy,List<Map<String,Object>> recordList){
        String code = "200" ;
        try{
//            String field_ry = "977243460998938628";
//            String field_tabymmc = "977680413716267009";
//            String field_qy = "977701557798322178";
//            String field_xssx = "981394667260444674";
//            String objId = "977243418007322626";

            String pkey = "uf_zzfwrktaby.ry";
            String field_ry =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

            pkey = "uf_zzfwrktaby.tabymmc";
            String field_tabymmc = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

            pkey = "uf_zzfwrktaby.qy";
            String field_qy = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

            pkey = "uf_zzfwrktaby.xssx";
            String field_xssx = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

            pkey = "uf_zzfwrktaby.objId";
            String objId = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

            List<EBDataReqDto> insertEbDataReqDtoList = Lists.newArrayList();
            List<EBDataReqDto> updateEbDataReqDtoList = Lists.newArrayList();
            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String name = String.valueOf(recordMap.get("name"));
                String tabid = getServiceTabId(employeeId,name,groupId,sourceType,uf_zzfwrktaby_qy,"0");
                log.error("tabid:"+tabid);
                if(StringUtils.isNotBlank(tabid)){
                    // 数据1
                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
                    // 设置更新id
                    mainData.add(new EBDataReqDetailDto("id", tabid));
                    // 单行文本
                    mainData.add(new EBDataReqDetailDto(field_tabymmc, name));
                    // 选择框根据选项名赋值
                    mainData.add(new EBDataReqDetailDto(field_qy, uf_zzfwrktaby_qy));
                    mainData.add(new EBDataReqDetailDto(field_xssx, i+""));
                    ebDataReqDto.setMainDatas(mainData);
                    updateEbDataReqDtoList.add(ebDataReqDto);

                }else{

                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
                    mainData.add(new EBDataReqDetailDto(field_ry, employeeId));
                    mainData.add(new EBDataReqDetailDto(field_tabymmc, name));
                    mainData.add(new EBDataReqDetailDto(field_qy, uf_zzfwrktaby_qy));
                    mainData.add(new EBDataReqDetailDto(field_xssx, i+""));
                    ebDataReqDto.setMainDatas(mainData);
                    insertEbDataReqDtoList.add(ebDataReqDto);
                }
            }

            log.error("insertEbDataReqDtoList:"+insertEbDataReqDtoList.size());
            if(insertEbDataReqDtoList !=null && insertEbDataReqDtoList.size()>0){
                jucailinPortalUtils.saveModeData(objId,employeeId,tenant_key,insertEbDataReqDtoList);
            }

            log.error("updateEbDataReqDtoList:"+updateEbDataReqDtoList.size());
            if(updateEbDataReqDtoList !=null && updateEbDataReqDtoList.size()>0){
                jucailinPortalUtils.updateModeDataById(objId,employeeId,tenant_key,updateEbDataReqDtoList,false);
            }
        }catch (Exception e){
            code = "-200";
            log.error("insertTabData-e:"+e);
        }
        log.error("insertTabData-code:"+code);
        return code;
    }

        /***
         *
         * @param employeeId
         * @param name
         * @param groupId
         * @param sourceType
         * @return
         */
    public String getServiceTabId(String employeeId,String name,String groupId,String sourceType,String uf_zzfwrktaby_qy,String type){
        String tabid = "" ;
        try{
            if("1".equals(type)){
                String sql = "select id from uf_zzfwrktaby where ry = ? and tabymmc = ? and qy = ? and delete_type=0 and tenant_key = ?";
                List<String> paramList = new ArrayList<>(100);
                paramList.add(employeeId);
                paramList.add(name);
                paramList.add(uf_zzfwrktaby_qy);
                paramList.add(tenant_key);
                List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(paramList);
                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(!recordList.isEmpty() && recordList.size()>0){
                    Map<String, Object> recordMap = recordList.get(0);
                    tabid = String.valueOf(recordMap.get("id"));
                }
            }else{
                String sql = "select id from uf_zzfwrktaby where ry = ? and tabymmc = ? and delete_type=0 and tenant_key = ?";
                List<String> paramList = new ArrayList<>(100);
                paramList.add(employeeId);
                paramList.add(name);
                paramList.add(tenant_key);
                List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(paramList);
                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(!recordList.isEmpty() && recordList.size()>0){
                    Map<String, Object> recordMap = recordList.get(0);
                    tabid = String.valueOf(recordMap.get("id"));
                }
            }
        }catch (Exception e){
            log.error("getTabId-e:"+e);
        }
        return tabid;
    }

    /**
     *
     * @param employeeId
     * @param groupId
     * @param sourceType
     * @param selectvalue
     * @param tabid
     * @return
     */
    public int initCustomServiceDataByType(String employeeId,String groupId,String sourceType,String selectvalue,String tabid,String uf_zzfwrktaby_qy){

        int errcount = 0 ;

//        String field_ry = "977242052157390850";
//        String field_fwmc = "977686396664430594";
//        String field_fwdz = "977686396664430595";
//        String field_fwtb = "977686869110833154";
//        String field_qy = "977703984547119105";
//        String field_xssx = "981394744418861058";

//        String field_taby = "977686869110833157";

//        String objId = "977240471802363906";


        String pkey = "uf_zzfwrkpz.ry";
        String field_ry =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwrkpz.fwmc";
        String field_fwmc = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwrkpz.fwdz";
        String field_fwdz = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwrkpz.fwtb";
        String field_fwtb = jucailinPortalUtils.getUfPropData(pkey,tenant_key);


        pkey = "uf_zzfwrkpz.qy";
        String field_qy = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwrkpz.xssx";
        String field_xssx = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwrkpz.taby";
        String field_taby = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_zzfwrkpz.objId";
        String objId = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        try{
            String sql =" select t.taby,t.fwtb,t.fwmc,t.fwdz " +
                        " from uf_zzfwcsh t \n" +
                        " where t.delete_type=0 \n" +
                        " and t.taby= ?" +
                        " and t.tenant_key = ?" +
                        " order by ifnull(t.xssx,0) ";

            log.error("initCustomServiceDataByType--sql:"+sql);
            List<String> paramList = new ArrayList<>(100);
            paramList.add(selectvalue);
            paramList.add(tenant_key);
            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(paramList);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);

            log.error("initCustomServiceDataByType--recordList:"+recordList.size());

            List<EBDataReqDto> EBDataReqDtoList = Lists.newArrayList();

            for(int i=0;i<recordList.size();i++){
                Map<String,Object> recordMap = recordList.get(i);
                String fwtb = String.valueOf(recordMap.get("fwtb"));
                String fwmc = String.valueOf(recordMap.get("fwmc"));
                String fwdz = String.valueOf(recordMap.get("fwdz"));

                EBDataReqDto ebDataReqDto = new EBDataReqDto();
                List<EBDataReqDetailDto> mainData = Lists.newArrayList();
                mainData.add(new EBDataReqDetailDto(field_ry, employeeId));
                mainData.add(new EBDataReqDetailDto(field_fwmc, fwmc));
                mainData.add(new EBDataReqDetailDto(field_fwdz, fwdz));
                mainData.add(new EBDataReqDetailDto(field_fwtb, fwtb));
                mainData.add(new EBDataReqDetailDto(field_qy, uf_zzfwrktaby_qy));
                mainData.add(new EBDataReqDetailDto(field_xssx, i+""));
                mainData.add(new EBDataReqDetailDto(field_taby, tabid));
                ebDataReqDto.setMainDatas(mainData);
                EBDataReqDtoList.add(ebDataReqDto);
            }
            log.error("EBDataReqDtoList:"+EBDataReqDtoList.size());
            if(EBDataReqDtoList !=null && EBDataReqDtoList.size()>0){
                jucailinPortalUtils.saveModeData(objId,employeeId,tenant_key,EBDataReqDtoList);
            }
        }catch (Exception e){
            errcount++;
        }
        return errcount;
    }

    /***
     *
     * @param employeeId
     * @return
     */
    public Map<String,Object> updateSelfServiceData(String employeeId){

        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";

        Map<String,Object> recordMap = new HashMap<String,Object>();

        String code1 = "" ;
        String code2 = "" ;
        try{

            if(StringUtils.isNotBlank(employeeId)){
                String sql1 =" update uf_zzfwrktaby set delete_type = 1,is_delete=1 where ry ="+employeeId+" and tenant_key='"+tenant_key+"' ";
                Map<String, Object> result1 = databaseUtils.execute(sourceType, groupId, sql1);
                Iterator<Map.Entry<String, Object>> iterator1 = result1.entrySet().iterator();
                while (iterator1.hasNext()){
                    Map.Entry<String, Object> next = iterator1.next();
                    log.error("insertCustomServiceData--key="+next.getKey()+"  value="+String.valueOf(next.getValue()));
                }
                if(result1.containsKey("code")){
                    code1 = String.valueOf(result1.get("code"));
                }

                String sql2 =" update uf_zzfwrkpz set delete_type = 1,is_delete=1 where ry ="+employeeId+" and tenant_key='"+tenant_key+"'";
                Map<String, Object> result2 = databaseUtils.execute(sourceType, groupId, sql2);
                Iterator<Map.Entry<String, Object>> iterator2 = result2.entrySet().iterator();
                while (iterator2.hasNext()){
                    Map.Entry<String, Object> next = iterator2.next();
                    log.error("insertCustomServiceData--key="+next.getKey()+"  value="+String.valueOf(next.getValue()));
                }
                if(result2.containsKey("code")){
                    code2 = String.valueOf(result2.get("code"));
                }
            }

        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
            recordMap.put("code","-200");
        }

        recordMap.put("code1",code1);
        recordMap.put("code2",code2);

        return recordMap;
    }

}
