package com.weaver.seconddev.jcldoor.controller;

import com.weaver.common.authority.annotation.WeaPermission;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.ebuilder.datasource.api.entity.SqlParamEntity;
import com.weaver.ebuilder.datasource.api.enums.SqlParamType;
import com.weaver.ebuilder.form.client.entity.data.EBDataReqDetailDto;
import com.weaver.ebuilder.form.client.entity.data.EBDataReqDto;
import com.weaver.ebuilder.form.client.entity.obj.Obj;
import com.weaver.ebuilder.form.client.service.emobile.IEtFormDatasetService;
import com.weaver.ebuilder.form.client.service.obj.RemoteEBObjService;
import com.weaver.framework.remote.client.rest.RestClient;
import com.weaver.framework.rpc.annotation.RpcReference;
import com.weaver.framework.rpc.context.impl.TenantRpcContext;
import com.weaver.mc.api.async.AsyncSystemMessageRest;
import com.weaver.mc.api.rest.SystemMessageRest;
import com.weaver.seconddev.jcldoor.util.ChatDayUtils;
import com.weaver.seconddev.jcldoor.util.ChatGroupUtils;
import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.seconddev.jcldoor.util.JucailinPortalUtils;
import com.weaver.teams.blog.domain.RemoteBlogInfoService;
import com.weaver.teams.client.doc.remote.DocClientService;
import com.weaver.teams.domain.hr.RemoteHrKpiService;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import com.weaver.workflow.common.constant.list.api.DateTimeConditionEnum;
import com.weaver.workflow.common.constant.list.listdimension.RequestListInitDimensionTabEnum;
import com.weaver.workflow.common.entity.list.api.RequestListConditionApiEntity;
import com.weaver.workflow.common.entity.list.api.publicapi.RequestCountInfoPAEntity;
import com.weaver.workflow.list.api.rest.publicapi.WflRequestListRest;
import com.weaver.workrelate.performance.api.rest.RemotePerformanceService;
import org.apache.commons.compress.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.time.format.DateTimeFormatter;
import java.util.*;

@RestController
@RequestMapping("/api/secondev/njjcldoor")
public class HrmSelfHelpController {

    //日志
    private final Logger log = LoggerFactory.getLogger(HrmSelfHelpController.class);

    @Autowired
    private RestClient restClient;

    @RpcReference
    public RemotePerformanceService remotePerformanceService ;

    @RpcReference
    public RemoteHrKpiService remoteHrKpiService ;

    @RpcReference(group = "workflow")
    WflRequestListRest wflRequestListRest;

    @RpcReference
    DocClientService docClientService;

    @RpcReference
    private com.weaver.em.msg.api.rest.OaRest oaRest;

    @RpcReference
    private RemoteBlogInfoService remoteBlogInfoService ;

    @RpcReference(group = "ebuilderform")
    private RemoteEBObjService remoteEBObjService;

    @RpcReference
    private IEtFormDatasetService IEtFormDatasetService;

    @Autowired
    private DatabaseUtils databaseUtils;

    @Autowired
    private JucailinPortalUtils jucailinPortalUtils;

    @Autowired
    private ChatDayUtils chatDayUtils;

    @Autowired
    private ChatGroupUtils chatGroupUtils;


    @Autowired
    private AsyncSystemMessageRest asyncSystemMessageRest;

    @RpcReference
    SystemMessageRest systemMessageRest;

    @Autowired
    private com.weaver.seconddev.jcldoor.cmd.UserInfoCmd userInfoCmd ;

    public String tenant_key = "t7akvdnf84" ;


//    @GetMapping("/testSapi12")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi12(HttpServletRequest request){
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi13");
//
//        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
//        try {
//
//            String pageSize = request.getParameter("pagesize");
//            String pageNum = request.getParameter("pagenum");
//            String startDate = request.getParameter("startDate");
//
//            SimpleEmployee employee = UserContext.getCurrentUser();
//            if(StringUtils.isBlank(startDate)){
//                startDate = "2001-01-01";
//            }
//
//            Calendar cal = Calendar.getInstance();
//            //设置当前时间
//            cal.setTime(new Date());
//            //同理增加一天的方法：
//            cal.add(Calendar.DATE, -1);
//            String endDate = format.format(cal.getTime());
//            Long cid = employee.getCid();
//            dataMap.put("startDate",startDate);
//            dataMap.put("endDate",endDate);
//            dataMap.put("cid",cid);
//
//            dataMap.put("pageSize",pageSize);
//            dataMap.put("pageNum",pageNum);
//
//
//            Map<String, Object> json = new HashMap<String, Object>();
//            json.put("cid",cid);
//            json.put("pageNum",pageNum);
//            json.put("pageSize",pageSize);
//            json.put("startDate",startDate);
//            json.put("endDate",endDate);
//
//            com.weaver.em.msg.api.entity.Request emrequest = new com.weaver.em.msg.api.entity.Request();
//            emrequest.setUrl("/user-profile/dailySingleSession");
//            emrequest.setParamsMap(json);
//            emrequest.setAsync(false);
//            com.weaver.em.msg.api.entity.Response response2 = oaRest.executeIm(emrequest);
//            String data = response2.getData();
//            dataMap.put("datas",data);
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi13:"+e);
//            dataMap.put("count","-1");
//        }
//        return WeaResult.success(dataMap);
//    }
//
//
//    @GetMapping("/testSapi13")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi13(HttpServletRequest request){
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi13");
//
//        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
//        try {
//
//            String pageSize = request.getParameter("pagesize");
//            String pageNum = request.getParameter("pagenum");
//            String startDate = request.getParameter("startDate");
//
//            SimpleEmployee employee = UserContext.getCurrentUser();
//            if(StringUtils.isBlank(startDate)){
//                startDate = "2001-01-01";
//            }
//
//            Calendar cal = Calendar.getInstance();
//            //设置当前时间
//            cal.setTime(new Date());
//            //同理增加一天的方法：
//            cal.add(Calendar.DATE, -1);
//            String endDate = format.format(cal.getTime());
//            Long cid = employee.getCid();
//            dataMap.put("startDate",startDate);
//            dataMap.put("endDate",endDate);
//            dataMap.put("cid",cid);
//
//            dataMap.put("pageSize",pageSize);
//            dataMap.put("pageNum",pageNum);
//
//
//            Map<String, Object> json = new HashMap<String, Object>();
//            json.put("cid",cid);
//            json.put("pageNum",pageNum);
//            json.put("pageSize",pageSize);
//            json.put("startDate",startDate);
//            json.put("endDate",endDate);
//
//            com.weaver.em.msg.api.entity.Request emrequest = new com.weaver.em.msg.api.entity.Request();
//            emrequest.setUrl("/user-profile/groupSession");
//            emrequest.setParamsMap(json);
//            emrequest.setAsync(false);
//            com.weaver.em.msg.api.entity.Response response2 = oaRest.executeIm(emrequest);
//            String data = response2.getData();
//            dataMap.put("datas",data);
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi13:"+e);
//            dataMap.put("count","-1");
//        }
//        return WeaResult.success(dataMap);
//    }


//    @GetMapping("/testSapi15")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi15(HttpServletRequest request){
//        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi15");
//        try {
//            String tablename = "uf_nj_cyqltjb" ;
//            dataMap.put("tablename",tablename);
//            Map<String,Object> dMap = jucailinPortalUtils.getChatGroup(tenant_key,tablename);
//            dataMap.putAll(dMap);
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi14:"+e);
//            dataMap.put("count","-1");
//        }
//        return WeaResult.success(dataMap);
//    }
//
//
//    @GetMapping("/testSapi16")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi16(HttpServletRequest request){
//        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi16");
//        try {
//            String tablename = "uf_nj_pjmrdlhhsl" ;
//            dataMap.put("tablename",tablename);
//            Map<String,Object> dMap = jucailinPortalUtils.getChatDay(tenant_key,tablename);
//            dataMap.putAll(dMap);
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi14:"+e);
//            dataMap.put("count","-1");
//        }
//        return WeaResult.success(dataMap);
//    }

//    @GetMapping("/testSapi30")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi30(HttpServletRequest request){
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi30");
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//        try {
//
//            String employeeId = request.getParameter("employeeId");
//            String startday = request.getParameter("startday");
//            String endday = request.getParameter("endday");
//
//            Calendar calendar = Calendar.getInstance();
//            int year = calendar.get(Calendar.YEAR);
//
//            if(StringUtils.isBlank(startday)){
//                startday = year+"-01-01";
//            }
//            if(StringUtils.isBlank(endday)){
//                endday = sdf.format(new Date());
//            }
//            if(StringUtils.isBlank(employeeId)){
//                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
//            }
//
//            dataMap.put("employeeId",employeeId);
//            dataMap.put("startday",startday);
//            dataMap.put("endday",endday);
//
//            String groupId = "weaver-ebuilder-form-service";
//            String sourceType = "LOGIC";
//
//            String sql =" select CONVERT(sum(cast(t1.htzje as decimal(18,2))),CHAR) as htzje," +
//                        "        CONVERT(sum(cast(t1.htyxje as decimal(18,2))),CHAR) as htyxje," +
//                        "        CONVERT(sum(cast(t1.sumsk as decimal(18,2))),CHAR) as sumsk " +
//                        " from uf_jxhs_xmys t1 \n" +
//                        " where t1.ysrq>=? and t1.ysrq<= ? " +
//                        " and ( t1.qyjl = ? "+
//                        "       or t1.qyjl in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= ?)\n" +
//                        "       or t1.ysry = ? \n" +
//                        "       or t1.ysry in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= ?)\n" +
//                        "       or t1.dqfzr = ? \n" +
//                        "       or t1.dqfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= ?)\n" +
//                        "       or t1.tdjl = ?\n" +
//                        "       or t1.tdjl in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= ?)\n" +
//                        "       or t1.tdfzr = ? \n" +
//                        "       or t1.tdfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= ?)\n" +
//                        "       or t1.jgfzr = ?\n" +
//                        "       or t1.jgfzr in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= ?)\n" +
//                        "       or t1.dqzj = ? \n" +
//                        "       or t1.dqzj in (select cid  from eteams.EMP_LINK where RELATION in ('othersenior','senior') and pid= ?) " +
//                        " ) " ;
//
//            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//            SqlParamEntity sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(startday);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(endday);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//            dataMap.put("datas",recordList);
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi30:"+e);
//            dataMap.put("count","-1");
//        }
//        return WeaResult.success(dataMap);
//    }
//
//
//    @GetMapping("/testSapi31")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi31(HttpServletRequest request){
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi31");
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//        try {
//
//            String startday = request.getParameter("startday");
//            String endday = request.getParameter("endday");
//            String employeeId = request.getParameter("employeeId");
//
//            Calendar calendar = Calendar.getInstance();
//            int year = calendar.get(Calendar.YEAR);
//
//            if(StringUtils.isBlank(startday)){
//                startday = year+"-01-01";
//            }
//            if(StringUtils.isBlank(endday)){
//                endday = sdf.format(new Date());
//            }
//
//            if(StringUtils.isBlank(employeeId)){
//                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
//            }
//
//            dataMap.put("employeeId",employeeId);
//            dataMap.put("startday",startday);
//            dataMap.put("endday",endday);
//
//            String groupId = "weaver-ebuilder-form-service";
//            String sourceType = "LOGIC";
//
//            String sql =" SELECT \n" +
//                    "   CONVERT(sum(cast(t1.skje as decimal(18,2))),CHAR) as skje,\n" +  //收款金额
//                    "   CONVERT(sum(cast(t1.xmskje as decimal(18,2))),CHAR) as xmskje,\n" + // 项目收款金额
//                    "   CONVERT(sum(cast(t1.xsyxje as decimal(18,2))),CHAR) as xsyxje," + // 销售有效金额
//                    "   CONVERT(sum(cast(t1.xsje as decimal(18,2))),CHAR) as xsje," + // 销售金额
//                    "   CONVERT(sum(cast(t1.xmyxje as decimal(18,2))),CHAR) as xmyxje," + //项目有效金额
//                    "   CONVERT(sum(cast(t1.xsjxhk as decimal(18,2))),CHAR) as xsjxhk," + //有效绩效回款
//                    "   CONVERT(sum(cast(t1.sumsk as decimal(18,2))),CHAR) as sumsk," + //总收款金额
//                    "   CONVERT(sum(cast(t1.sjjsk as decimal(18,2))),CHAR) as sjjsk," + //实际结算款
//                    "   CONVERT(sum(cast(t1.skjs as decimal(18,2))),CHAR) as skjs " +  //收款结算
//                    " FROM uf_jxhs_skmx t1\n" +
//                    " LEFT JOIN uf_jxhs_zxhtzb t2 ON t1.hth = t2.hth AND t2.hth != '' AND t2.hth IS NOT NULL \n" +
//                    " LEFT JOIN ebdf_physical_data epd on t1.id = epd.form_data_id  and epd.delete_type = 0 \n" +
//                    " WHERE t1.skje != 0 \n" +
//                    " and t1.skje IS NOT NULL " +
//                    " and t1.xshsny >= ? and t1.xshsny <= ? "+
//                    " and (" +
//                    "   ? IN ( 2, 27, 166, 10285, 11661, 300, 876, 3593, 1416, 1647, 1844,3044480226941419013,794508876297846787 ) \n" +
//                    "   or cast(t1.xsjl AS decimal(25,0)) in( \n" +
//                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid = ?  and RELATION in ('othersenior','senior') \n" +
//                    "       UNION  " +
//                    "       SELECT id FROM eteams.employee WHERE id = ? " +
//                    "   )\n" +
//                    "   or cast(t1.kfry AS decimal(25,0)) in(\n" +
//                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  ?  and RELATION in ('othersenior','senior') \n" +
//                    "       UNION  " +
//                    "       SELECT id FROM eteams.employee WHERE id =  ? " +
//                    "   )\n" +
//                    "   or cast(t1.qdjl AS decimal(25,0)) in(\n" +
//                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid =  ?  and RELATION in ('othersenior','senior') \n" +
//                    "       UNION  " +
//                    "       SELECT id FROM eteams.employee WHERE id = ? " +
//                    "   )\n" +
//                    "   or cast(t1.xmjl AS decimal(25,0)) in(\n" +
//                    "       SELECT cid AS id FROM eteams.emp_link WHERE pid = ? and RELATION in ('othersenior','senior') \n" +
//                    "       UNION  " +
//                    "       SELECT id FROM eteams.employee WHERE id =  ? " +
//                    "   )\n" +
//                    " )\n" +
//                    " order by t1.id " ;
//
//
//            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//            SqlParamEntity sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(startday);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(endday);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            log.error("sql:"+sql);
//            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//            dataMap.put("datas",recordList);
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi30:"+e);
//            dataMap.put("count","-1");
//        }
//        return WeaResult.success(dataMap);
//    }


//    /***
//     * 本年沟通协作数
//     * @param request
//     * @return
//     */
//    @GetMapping("/testSapi51")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi51(HttpServletRequest request){
//        log.error("getPortalWorkFlowInfo");
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//
//        String groupId = "weaver-cowork-service";
//        String sourceType = "LOGIC";
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        try{
//            String startday = request.getParameter("startday");
//            String endday = request.getParameter("endday");
//            String employeeId = request.getParameter("employeeId");
//
//            Calendar calendar = Calendar.getInstance();
//            int year = calendar.get(Calendar.YEAR);
//
//            if(StringUtils.isBlank(startday)){
//                startday = year+"-01-01";
//            }
//            if(StringUtils.isBlank(endday)){
//                endday = sdf.format(new Date());
//            }
//
//            if(StringUtils.isBlank(employeeId)){
//                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
//            }
//
//            String sql =" select count(1) as cou from cw_content " +
//                        " where CREATOR= ? " +
//                        " and left(CREATE_TIME,10)>=? and left(CREATE_TIME,10) <= ? " ;
//
//            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//            SqlParamEntity sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(employeeId);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(startday);
//            sqlparam.add(sqlParamEntity);
//
//            sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(endday);
//            sqlparam.add(sqlParamEntity);
//
//            log.error("sql:"+sql);
//
//            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//            if(recordList.size()>0){
//                dataMap = recordList.get(0);
//            }
//        }catch (Exception e){
//            log.error("testSapi51-Exception:"+e.getMessage());
//            return WeaResult.fail(500,"程序执行异常");
//        }
//        return WeaResult.success(dataMap);
//    }



    /***
     * 本年沟通协作数
     * @param request
     * @return
     */
//    @GetMapping("/testSapi511")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi511(HttpServletRequest request){
//        log.error("testSapi511");
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//
//        String groupId = "weaver-cowork-service";
//        String sourceType = "LOGIC";
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        try{
//            String startday = request.getParameter("startday");
//            String endday = request.getParameter("endday");
//            String employeeId = request.getParameter("employeeId");
//
//            Calendar calendar = Calendar.getInstance();
//            int year = calendar.get(Calendar.YEAR);
//
//            if(StringUtils.isBlank(startday)){
//                startday = year+"-01-01";
//            }
//            if(StringUtils.isBlank(endday)){
//                endday = sdf.format(new Date());
//            }
//
//            if(StringUtils.isBlank(employeeId)){
//                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
//            }
//
//            String sql =" select count(1) as cou from cw_content " +
//                        " where  CREATOR= " +SecurityUtil.ecodeForSql(employeeId)+
//                        " and left(CREATE_TIME,10)>="+SecurityUtil.ecodeForSql(startday)+" and left(CREATE_TIME,10) <= "+SecurityUtil.ecodeForSql(endday) ;
//
//            log.error("sql:"+sql);
//            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
//            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//            if(recordList.size()>0){
//                dataMap = recordList.get(0);
//            }
//        }catch (Exception e){
//            log.error("testSapi51-Exception:"+e.getMessage());
//            return WeaResult.fail(500,"程序执行异常");
//        }
//        return WeaResult.success(dataMap);
//    }

    /**
     * 本年处理流程数
     * @param request
     * @return
     */
    @GetMapping("/testSapi60")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi60(HttpServletRequest request){
        log.error("testSapi60");
        Long count = 0L ;
        try{
            RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
            SimpleEmployee employee = UserContext.getCurrentUser();
            log.error("employee--:"+employee.getEmployeeId());

            conditionEntity.setOperatedate(DateTimeConditionEnum.CURRENT_YEAR);
            log.error("conditionEntity--:"+conditionEntity.toString());

            WeaResult<RequestCountInfoPAEntity>  requestCountInfo = wflRequestListRest.getRequestCountByTabId(employee, RequestListInitDimensionTabEnum.DONE_FLOWALL.getTabid(), conditionEntity);
            log.error("requestCountInfo--:"+requestCountInfo.toString());
            int code = requestCountInfo.getCode();
            log.error("code--:"+code);
            if(code == 200){
                RequestCountInfoPAEntity requestCountInfoPAEntity = requestCountInfo.getData();
                log.error("requestCountInfoPAEntity--:"+requestCountInfoPAEntity.toString());
                count = requestCountInfoPAEntity.getCount();
                log.error("count--:"+count);
            }
        }catch (Exception e){
            log.error("getWorkFlowInfo-Exception:"+e.getMessage());
            return WeaResult.fail(500,"程序执行异常");
        }
        return WeaResult.success(count);
    }


    /**
     * 本年处理流程数
     * @param request
     * @return
     */
//    @GetMapping("/testSapi61")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi61(HttpServletRequest request){
//        log.error("testSapi61");
//
//        String startday = request.getParameter("startday");
//        String endday = request.getParameter("endday");
//        DateTimeFormatter format = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
//
//        String defineTime = " 00:00:01";
//        Long count = 0L ;
//        try{
//            RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
//            SimpleEmployee employee = UserContext.getCurrentUser();
//            log.error("employee--:"+employee.getEmployeeId());
//
//            conditionEntity.setOperatedate(DateTimeConditionEnum.CUSTOM_DATE);
//
//            LocalDateTime startDateTime = LocalDateTime.of(LocalDate.from(LocalDateTime.now().with(TemporalAdjusters.firstDayOfYear())), LocalTime.MIN);
//            if(StringUtils.isNotBlank(startday)){
//                startDateTime = LocalDateTime.parse(startday+defineTime, format);
//            }
//            LocalDateTime endDateTime = LocalDateTime.now();
//            if(StringUtils.isNotBlank(endday)){
//                endDateTime = LocalDateTime.parse(endday+defineTime, format);
//            }
//            conditionEntity.setCusOperateDateStart(startDateTime);
//            conditionEntity.setCusOperateDateEnd(endDateTime);
//
//            log.error("conditionEntity--:"+conditionEntity.toString());
//
//            WeaResult<RequestCountInfoPAEntity>  requestCountInfo = wflRequestListRest.getRequestCountByTabId(employee, RequestListInitDimensionTabEnum.DONE_FLOWALL.getTabid(), conditionEntity);
//            log.error("requestCountInfo--:"+requestCountInfo.toString());
//            int code = requestCountInfo.getCode();
//            log.error("code--:"+code);
//            if(code == 200){
//                RequestCountInfoPAEntity requestCountInfoPAEntity = requestCountInfo.getData();
//                log.error("requestCountInfoPAEntity--:"+requestCountInfoPAEntity.toString());
//                count = requestCountInfoPAEntity.getCount();
//                log.error("count--:"+count);
//            }
//        }catch (Exception e){
//            log.error("getWorkFlowInfo-Exception:"+e.getMessage());
//            return WeaResult.fail(500,"程序执行异常");
//        }
//        return WeaResult.success(count);
//    }

    /***
     * 本年开发人天
     * @param request
     * @return
     */
//    @GetMapping("/testSapi70")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi70(HttpServletRequest request){
//
//        log.error("testSapi70");
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//
//        String groupId = "weaver-workflow-report-serviceworkflowreport";
//        String sourceType = "LOGIC";
//
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        String devcou = "0" ;
//        try{
//            String startday = request.getParameter("startday");
//            String endday = request.getParameter("endday");
//            String employeeId = request.getParameter("employeeId");
//
//            Calendar calendar = Calendar.getInstance();
//            int year = calendar.get(Calendar.YEAR);
//
//            if(StringUtils.isBlank(startday)){
//                startday = year+"-01-01";
//            }
//            if(StringUtils.isBlank(endday)){
//                endday = sdf.format(new Date());
//            }
//
//            if(StringUtils.isBlank(employeeId)){
//                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
//            }
//
//            if(StringUtils.isNotBlank(employeeId))
//            {
//                String dataSql =" select ifnull(sum(d.integer2),0) as devcou \n" +
//                                " from wfc_form_data l\n" +
//                                " inner join fto_62 d on d.id = l.dataid\n" +
//                                " inner join wfc_requestbase p on p.requestid = l.requestid\n" +
//                                " where d.multiresource5= ? \n" +
//                                " and d.date2 >= ? "+
//                                " and d.date2 <= ? "+
//                                " and d.tenant_key='"+tenant_key+"'\n" +
//                                " and d.is_delete='0'\n" +
//                                " and l.tenant_key='"+tenant_key+"'\n" +
//                                " and l.delete_type=0\n" +
//                                " and p.tenant_key='"+tenant_key+"'\n" +
//                                " and p.delete_type=0\n" +
//                                " order by d.id desc " ;
//
//                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//                SqlParamEntity sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(employeeId);
//                sqlparam.add(sqlParamEntity);
//
//                sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(startday);
//                sqlparam.add(sqlParamEntity);
//
//                sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(endday);
//                sqlparam.add(sqlParamEntity);
//
//                log.info("dataSql:"+dataSql);
//
//                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, dataSql,sqlparam);
//                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//                if(CollectionUtils.isNotEmpty(recordList)) {
//                    devcou = String.valueOf(recordList.get(0).get("devcou"));
//                }
//            }
//
//        }catch (Exception e){
//            log.error("testSapi51-Exception:"+e.getMessage());
//            return WeaResult.fail(500,"程序执行异常");
//        }
//        return WeaResult.success(devcou);
//
//    }



    /***
     * 本年开发人天
     * @param request
     * @return
     */
//    @GetMapping("/testSapi71")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi71(HttpServletRequest request){
//
//        log.error("testSapi71");
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//
//        String groupId = "weaver-workflow-report-serviceworkflowreport";
//        String sourceType = "LOGIC";
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        String devcou = "0" ;
//        try{
//            String startday = request.getParameter("startday");
//            String endday = request.getParameter("endday");
//            String employeeId = request.getParameter("employeeId");
//
//            Calendar calendar = Calendar.getInstance();
//            int year = calendar.get(Calendar.YEAR);
//
//            if(StringUtils.isBlank(startday)){
//                startday = year+"-01-01";
//            }
//            if(StringUtils.isBlank(endday)){
//                endday = sdf.format(new Date());
//            }
//
//            if(StringUtils.isBlank(employeeId)){
//                employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
//            }
//
//            if(StringUtils.isNotBlank(employeeId))
//            {
//                String dataSql =" select count(1) as devcou \n" +
//                                " from wfc_form_data l\n" +
//                                " inner join fto_83 d on d.id = l.dataid\n" +
//                                " inner join wfc_requestbase p on p.requestid = l.requestid\n" +
//                                " where d.mutiresource= ?\n" +
//                                " and d.xsjfrq >= ? "+
//                                " and d.xsjfrq <=? "+
//                                " and d.tenant_key='"+tenant_key+"'\n" +
//                                " and d.is_delete='0'\n" +
//                                " and l.tenant_key='"+tenant_key+"'\n" +
//                                " and l.delete_type=0\n" +
//                                " and p.tenant_key='"+tenant_key+"'\n" +
//                                " and p.delete_type=0\n" +
//                                " order by d.id desc " ;
//
//                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//                SqlParamEntity sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(employeeId);
//                sqlparam.add(sqlParamEntity);
//
//                sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(startday);
//                sqlparam.add(sqlParamEntity);
//
//                sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(endday);
//                sqlparam.add(sqlParamEntity);
//
//                log.info("dataSql:"+dataSql);
//
//                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, dataSql,sqlparam);
//                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//                if(CollectionUtils.isNotEmpty(recordList)) {
//                    devcou = String.valueOf(recordList.get(0).get("devcou"));
//                }
//            }
//
//        }catch (Exception e){
//            log.error("testSapi51-Exception:"+e.getMessage());
//            return WeaResult.fail(500,"程序执行异常");
//        }
//        return WeaResult.success(devcou);
//    }


//    @GetMapping("/testSapi110")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi110(HttpServletRequest request){
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi110");
//        try {
//            SimpleEmployee employee = UserContext.getCurrentUser();
//            log.error("employee:"+employee.getEmployeeId());
//
//            RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
//            WeaResult<RequestCountInfoPAEntity> requestCountInfo = wflRequestListRest.getRequestCountByTabId(employee, RequestListInitDimensionTabEnum.MINE_FLOWALL.getTabid(), conditionEntity);
//            log.error("testSapi110:"+requestCountInfo.toString());
//            int code = requestCountInfo.getCode();
//            log.error("testSapi110:"+code);
//            RequestCountInfoPAEntity requestCountInfoPAEntity = requestCountInfo.getData();
//            log.error("testSapi110:"+requestCountInfoPAEntity.toString());
//            dataMap.put("data",requestCountInfoPAEntity);
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi11:"+e);
//            dataMap.put("count","-1");
//        }
//        return WeaResult.success(dataMap);
//    }
//
//
//    @GetMapping("/testSapi112")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<RequestCountInfoPAEntity> testSapi112(HttpServletRequest request){
//
//        SimpleEmployee employee = UserContext.getCurrentUser();
//        log.error("employee:"+employee.getEmployeeId());
//        RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
//        WeaResult<RequestCountInfoPAEntity> requestCountInfo = wflRequestListRest.getRequestCountByTabId(employee, RequestListInitDimensionTabEnum.MINE_FLOWALL.getTabid(), conditionEntity);
//        log.error("testSapi110:"+requestCountInfo.toString());
//        return requestCountInfo;
//    }
//
//    @GetMapping("/testSapi113")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<RequestCountInfoPAEntity> testSapi113(HttpServletRequest request){
//
//        SimpleEmployee employee = UserContext.getCurrentUser();
//        log.error("employee:"+employee.getEmployeeId());
//        RequestListConditionApiEntity conditionEntity = new RequestListConditionApiEntity();
//        WeaResult<RequestCountInfoPAEntity> requestCountInfo = wflRequestListRest.getRequestCountByTabId(employee, RequestListInitDimensionTabEnum.DONE_FLOWALL.getTabid(), conditionEntity);
//        log.error("testSapi110:"+requestCountInfo.toString());
//        return requestCountInfo;
//    }


//    @GetMapping("/testSapi80")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi80(HttpServletRequest request){
//
//        log.error("testSapi80");
//
//        String pkey = "uf_zzfwcsh.taby.fieldId";
//        String field_id =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);
//        log.error("field_id:"+field_id);
//
//        String groupId = "weaver-ebuilder-form-service";
//        String sourceType = "LOGIC";
//
//        String employeeId = request.getParameter("employeeId");
//
//        if(StringUtils.isBlank(employeeId)){
//            employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
//        }
//
//        List<Map<String,Object>> dataList  = new ArrayList<Map<String,Object>>();
//        try{
//
//            if(StringUtils.isNotBlank(field_id)){
//                String sql = " select distinct taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and delete_type=0 and tenant_key ='"+tenant_key+"'";
//                log.error("sql:"+sql);
//
//                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//                SqlParamEntity sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(employeeId);
//                sqlparam.add(sqlParamEntity);
//
//                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//                if(recordList.size()>0){
//                    // /api/file/preview?type=redirect&imgFormat=small&fileId=977697615197618177&module=ebuilderform&authModule=ebuilderform&source=form&fieldId=977686869110833154&customParam=%7B%22dataId%22%3A%22977697666574729218%22%7D&refId=977697666574729218&folderId=8120831157448215424
//                    dataList = getCustomeServiceData(groupId,sourceType,field_id,recordList,employeeId);
//                }else{
//                    dataList = getDefaultServiceData(groupId,sourceType,field_id);
//                }
//            }
//        }catch (Exception e){
//            log.error("testSapi51-Exception:"+e.getMessage());
//            return WeaResult.fail(500,"程序执行异常");
//        }
//        return WeaResult.success(dataList);
//    }
//
//
//    /***
//     *
//     * @param groupId
//     * @param sourceType
//     * @return
//     */
//    public Map<String,String> getCustomServiceTypeName(String groupId,String sourceType,String employeeId){
//
//        Map<String,String> optionMap = new HashMap<String,String>();
//        String sql = " select id,tabymmc from uf_zzfwrktaby where qy is not null and ry=? and delete_type=0 and tenant_key = '"+tenant_key+"'";
//        log.error("getCustomServiceTypeName-sql:"+sql);
//
//        List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//        SqlParamEntity sqlParamEntity = new SqlParamEntity();
//        sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//        sqlParamEntity.setValue(employeeId);
//        sqlparam.add(sqlParamEntity);
//
//        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//
//        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//        for(int i=0;i<recordList.size();i++){
//            Map<String,Object> recordMap = recordList.get(i);
//            String value = String.valueOf(recordMap.get("id"));
//            String name = String.valueOf(recordMap.get("tabymmc"));
//            log.error("getCustomServiceTypeName-value:"+value+" name:"+name);
//            optionMap.put(value,name);
//        }
//        return optionMap;
//    }
//
//
//    public List<Map<String,Object>> getCustomeServiceData(String groupId,String sourceType,String field_id,List<Map<String,Object>> recordList,String employeeId){
//
//        Map<String,String> optionMap = getCustomServiceTypeName(groupId,sourceType,employeeId);
//
//        for(int i=0;i<recordList.size();i++){
//            Map<String,Object> recordMap = recordList.get(i);
//            String taby = String.valueOf(recordMap.get("taby"));
//            log.error("getCustemSelfServiceType-taby:"+taby);
//
//            String tabyName = optionMap.get(taby);
//            List<Map<String,Object>> customList = getCustomeServiceDataByType(groupId,sourceType,taby,employeeId);
//
//            log.error("getCustemSelfServiceType-tabyName:"+tabyName);
//            log.error("getCustemSelfServiceType-taby:"+taby);
//            recordMap.put("menus",customList);
//            recordMap.put("name",tabyName);
//        }
//        return recordList;
//    }
//
//
//    /***
//     *
//     * @param groupId
//     * @param sourceType
//     * @param value
//     * @param employeeId
//     * @return
//     */
//    public List<Map<String,Object>> getCustomeServiceDataByType(String groupId,String sourceType,String value,String employeeId){
//        String sql = " select fwmc,fwdz,fwtb,taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and taby="+value+" and delete_type=0 and tenant_key = '"+tenant_key+"'";
//        log.info("getSelfServiceData--sql:"+sql);
//        List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//        SqlParamEntity sqlParamEntity = new SqlParamEntity();
//        sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//        sqlParamEntity.setValue(employeeId);
//        sqlparam.add(sqlParamEntity);
//
//        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//        for(int i=0;i<recordList.size();i++){
//            Map<String,Object> recordMap = recordList.get(i);
//            String fwtb = String.valueOf(recordMap.get("fwtb"));
//            String fwtburl = "";
//            if(StringUtils.isNotBlank(fwtb)){
//                fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
//            }
//            recordMap.put("fwtburl",fwtburl);
//        }
//        return recordList;
//    }
//
//
//    /***
//     *  默认数据
//     * @param groupId
//     * @param sourceType
//     * @return
//     */
//    public List<Map<String,Object>> getDefaultServiceData(String groupId,String sourceType,String field_id){
//
//        String sql = " select name,value_key as taby from field_option where field_id=? and delete_type=0 and tenant_key = '"+tenant_key+"'";
//        log.error("getDefaultServiceData-sql:"+sql);
//
//        List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//        SqlParamEntity sqlParamEntity = new SqlParamEntity();
//        sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//        sqlParamEntity.setValue(field_id);
//        sqlparam.add(sqlParamEntity);
//
//        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//
//        log.error("getDefaultServiceData-recordList:"+recordList.size());
//
//        for(int i=0;i<recordList.size();i++){
//            Map<String,Object> recordMap = recordList.get(i);
//            String taby = String.valueOf(recordMap.get("taby"));
//            log.error("getDefaultServiceData-taby:"+taby);
//            List<Map<String,Object>> defaultList =  getDefaultServiceDataByType(groupId,sourceType,taby);
//            recordMap.put("menus",defaultList);
//        }
//        return recordList;
//    }
//
//    /***
//     * 默认数据
//     * @param groupId
//     * @param sourceType
//     * @param value
//     * @return
//     */
//    public List<Map<String,Object>> getDefaultServiceDataByType(String groupId,String sourceType,String value){
//        String sql =" select t.taby,t.fwtb,t.fwmc,t.fwdz\n" +
//                " from uf_zzfwcsh t \n" +
//                " where t.delete_type=0 \n" +
//                " and t.taby= ? " +
//                " and t.tenant_key = '"+tenant_key+"'";
//
//        log.error("getDefaultServiceDataByType--sql:"+sql);
//
//        List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//        SqlParamEntity sqlParamEntity = new SqlParamEntity();
//        sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//        sqlParamEntity.setValue(value);
//        sqlparam.add(sqlParamEntity);
//
//        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//        log.error("getDefaultServiceDataByType--recordList:"+recordList.size());
//
//
//        for(int i=0;i<recordList.size();i++){
//            Map<String,Object> recordMap = recordList.get(i);
//            String fwtb = String.valueOf(recordMap.get("fwtb"));
//            String fwtburl = "";
//            if(StringUtils.isNotBlank(fwtb)){
//                fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
//            }
//            recordMap.put("fwtburl",fwtburl);
//        }
//        return recordList;
//    }


//    @GetMapping("/testSapi90")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi90(HttpServletRequest request){
//
//        String groupId = "weaver-ebuilder-form-service";
//        String sourceType = "LOGIC";
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi90");
//
//        try {
//            SimpleEmployee employee = UserContext.getCurrentUser();
//            log.error("employee:"+employee.getEmployeeId());
//
//            long formdata = employee.getFormdata();
//            dataMap.put("formdata",formdata);
//            log.error("formdata:"+formdata);
//
//            String sql =" select field69,field69_obj from eteams.Hrmemployeedefined where form_data_id=? " ;
//            dataMap.put("sql",sql);
//
//            log.error("getSelfServiceData--sql:"+sql);
//
//            List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//            SqlParamEntity sqlParamEntity = new SqlParamEntity();
//            sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//            sqlParamEntity.setValue(String.valueOf(formdata));
//            sqlparam.add(sqlParamEntity);
//
//            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//            dataMap.put("data90",recordList);
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi10:"+e);
//            dataMap.put("count","-1");
//        }
//        return WeaResult.success(dataMap);
//    }


//    @GetMapping("/testSapi110")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi110(HttpServletRequest request){
//
//        String groupId = "weaver-hr-service";
//        String sourceType = "LOGIC";
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi110");
//
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//        try {
//
//            String hip = "" ;
//            String nowDay = sdf.format(new Date());
//            SimpleEmployee employee = UserContext.getCurrentUser();
//            log.error("employee:"+employee.getEmployeeId());
//
//            long formdata = employee.getFormdata();
//            dataMap.put("formdata",formdata);
//            String tip_id = "" ;
//            String sql =" select id " +
//                        " from hr_tip\n" +
//                        " where TIP_TYPE='birthday'\n" +
//                        " and TENANT_KEY='t7akvdnf84'\n" +
//                        " and  DELETE_TYPE='0' " ;
//            dataMap.put("sql",sql);
//            log.error("--sql:"+sql);
//            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
//            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//            if(recordList.size()>0){
//                Map<String, Object> recordMap = recordList.get(0);
//                tip_id = String.valueOf(recordMap.get("id"));
//            }
//
//            String tip_target_id = "" ;
//            if(StringUtils.isNotBlank(tip_id)){
//                sql = " select id from hr_tip_target \n" +
//                      " where TIP_ID = ? \n" +
//                      " and TARGET_TYPE='colleague' \n" +
//                      " and tip_time_type='sameDay' ";
//                log.error("--sql:"+sql);
//                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//                SqlParamEntity sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(tip_id);
//                sqlparam.add(sqlParamEntity);
//
//                Map<String, Object> result2 = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//                List<Map<String,Object>> recordList2 = databaseUtils.getDataSourceList(result2);
//                if(recordList2.size()>0){
//                    Map<String, Object> recordMap = recordList2.get(0);
//                    tip_target_id = String.valueOf(recordMap.get("id"));
//                }
//            }
//
//            if(StringUtils.isNotBlank(tip_id) && StringUtils.isNotBlank(tip_target_id)){
//                sql = " select id \n" +
//                      " from hr_tip_send_history\n" +
//                      " where history_date = ? \n" +
//                      " and tip_id = ?  \n" +
//                      " and tip_target_id= ? \n" +
//                      " order by create_time desc " +
//                      " limit 1 ";
//                log.error("--sql:"+sql);
//
//                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//                SqlParamEntity sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(nowDay);
//                sqlparam.add(sqlParamEntity);
//
//                sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(tip_id);
//                sqlparam.add(sqlParamEntity);
//
//                sqlParamEntity = new SqlParamEntity();
//                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                sqlParamEntity.setValue(tip_target_id);
//                sqlparam.add(sqlParamEntity);
//
//                Map<String, Object> result3 = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//                List<Map<String,Object>> recordList3 = databaseUtils.getDataSourceList(result3);
//                if(recordList3.size()>0){
//                    Map<String, Object> recordMap = recordList3.get(0);
//                    hip = String.valueOf(recordMap.get("id"));
//                }
//            }
//            log.error("--hip:"+hip);
//            dataMap.put("hip",hip);
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi10:"+e);
//            dataMap.put("count","-1");
//        }
//        return WeaResult.success(dataMap);
//    }



//    @GetMapping("/testSapi8")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi8(HttpServletRequest request){
//
////        String field_ry = "985460777098248194" ;
////        String field_amount = "985460777098248195";
////        String objId = "985460643895541762";
//
//        String pkey = "uf_nj_cyqltjb.ry";
//        String field_ry =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);
//
//        pkey = "uf_nj_cyqltjb.amount";
//        String field_amount = jucailinPortalUtils.getUfPropData(pkey,tenant_key);
//
//        pkey = "uf_nj_cyqltjb.objId";
//        String objId = jucailinPortalUtils.getUfPropData(pkey,tenant_key);
//
//        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
//        log.error("testSapi8");
//        String groupId = "weaver-ebuilder-form-service";
//        String sourceType = "LOGIC";
//        SimpleEmployee employee = UserContext.getCurrentUser();
//        Long cid = employee.getCid();
//        long employeeId = employee.getEmployeeId();
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi8");
//        String tablename = "uf_nj_cyqltjb" ;
//        try {
//            String data = "{\"actionMsg\":{\"code\":0,\"message\":\"成功\",\"traceId\":\"1712556405230309576\"},\"data\":{\"count\":11149,\"data\":[{\"userid\":\"100001840000000001\",\"amount\":\"14970\"},{\"userid\":\"732740550661120001\",\"amount\":\"18\"},{\"userid\":\"732740623600066568\",\"amount\":\"1\"},{\"userid\":\"732740838411632644\",\"amount\":\"1\"},{\"userid\":\"732741031760855045\",\"amount\":\"1\"},{\"userid\":\"732742522042859521\",\"amount\":\"2\"},{\"userid\":\"732742595040526345\",\"amount\":\"1\"},{\"userid\":\"732742672291217409\",\"amount\":\"2\"},{\"userid\":\"732742676670070786\",\"amount\":\"3\"},{\"userid\":\"732742745263718407\",\"amount\":\"1\"},{\"userid\":\"732742749642571778\",\"amount\":\"1\"},{\"userid\":\"732742852663066628\",\"amount\":\"3\"},{\"userid\":\"732742998817783809\",\"amount\":\"114\"},{\"userid\":\"732743020326174725\",\"amount\":\"5\"},{\"userid\":\"732743097509756937\",\"amount\":\"1\"},{\"userid\":\"732743299473883145\",\"amount\":\"1\"},{\"userid\":\"732743479900602374\",\"amount\":\"3\"},{\"userid\":\"732743501174112259\",\"amount\":\"1\"},{\"userid\":\"732743509965373442\",\"amount\":\"1\"},{\"userid\":\"732743561404317704\",\"amount\":\"1\"},{\"userid\":\"732743574322774024\",\"amount\":\"1\"},{\"userid\":\"732743677301129221\",\"amount\":\"38\"},{\"userid\":\"732743694590050307\",\"amount\":\"1\"},{\"userid\":\"732743694590050309\",\"amount\":\"92\"},{\"userid\":\"732743763275972612\",\"amount\":\"17\"},{\"userid\":\"732743797551824905\",\"amount\":\"28\"},{\"userid\":\"732743969367293959\",\"amount\":\"1\"},{\"userid\":\"732743995195817994\",\"amount\":\"1\"},{\"userid\":\"732744046836088833\",\"amount\":\"1\"},{\"userid\":\"732744063789465602\",\"amount\":\"1\"},{\"userid\":\"732744300209512451\",\"amount\":\"140\"},{\"userid\":\"732748607919243273\",\"amount\":\"164\"},{\"userid\":\"732748616433680394\",\"amount\":\"1\"},{\"userid\":\"732748719584346115\",\"amount\":\"12\"},{\"userid\":\"732748736697106439\",\"amount\":\"2\"},{\"userid\":\"732749106277916679\",\"amount\":\"1\"},{\"userid\":\"732749209139027973\",\"amount\":\"194\"},{\"userid\":\"732749282237358084\",\"amount\":\"50\"},{\"userid\":\"732749350998777861\",\"amount\":\"4\"},{\"userid\":\"732749359664209929\",\"amount\":\"1\"},{\"userid\":\"732749368304476165\",\"amount\":\"3\"},{\"userid\":\"732749454091059204\",\"amount\":\"1\"},{\"userid\":\"732749548689391616\",\"amount\":\"26\"},{\"userid\":\"732749587352485894\",\"amount\":\"1\"},{\"userid\":\"732749724640444417\",\"amount\":\"1\"},{\"userid\":\"732749737449848834\",\"amount\":\"1\"},{\"userid\":\"732749784803540993\",\"amount\":\"1\"},{\"userid\":\"732749806345486337\",\"amount\":\"11\"},{\"userid\":\"732749939317161984\",\"amount\":\"1\"},{\"userid\":\"732749978139639811\",\"amount\":\"3\"},{\"userid\":\"732750210000625666\",\"amount\":\"55\"},{\"userid\":\"732750385998102533\",\"amount\":\"4\"},{\"userid\":\"732750454725967876\",\"amount\":\"159\"},{\"userid\":\"732750459180318726\",\"amount\":\"1\"},{\"userid\":\"732750471897448455\",\"amount\":\"1\"},{\"userid\":\"732750484958511108\",\"amount\":\"77\"},{\"userid\":\"732750506357850121\",\"amount\":\"1\"},{\"userid\":\"732750510585708546\",\"amount\":\"1\"},{\"userid\":\"732750600738078725\",\"amount\":\"1\"},{\"userid\":\"732750622389075969\",\"amount\":\"2\"},{\"userid\":\"732750630794461187\",\"amount\":\"36\"},{\"userid\":\"732750669457555456\",\"amount\":\"1\"},{\"userid\":\"732750824256585731\",\"amount\":\"2\"},{\"userid\":\"732750875661975559\",\"amount\":\"2\"},{\"userid\":\"732750879998885890\",\"amount\":\"26\"},{\"userid\":\"732750922847895559\",\"amount\":\"64\"},{\"userid\":\"732751163475116034\",\"amount\":\"57\"},{\"userid\":\"732751322388766727\",\"amount\":\"42\"},{\"userid\":\"732751416995487749\",\"amount\":\"1\"},{\"userid\":\"732752452082745349\",\"amount\":\"1023\"},{\"userid\":\"732766552330502146\",\"amount\":\"28\"},{\"userid\":\"732767007538315268\",\"amount\":\"1\"},{\"userid\":\"732767024684630017\",\"amount\":\"37\"},{\"userid\":\"732767213646610441\",\"amount\":\"108\"},{\"userid\":\"732767449907077128\",\"amount\":\"49\"},{\"userid\":\"732767475785932801\",\"amount\":\"478\"},{\"userid\":\"732767720641011721\",\"amount\":\"91\"},{\"userid\":\"732767888010518530\",\"amount\":\"17\"},{\"userid\":\"732767901012860929\",\"amount\":\"125\"},{\"userid\":\"732767905383325698\",\"amount\":\"106\"},{\"userid\":\"732767978154500099\",\"amount\":\"61\"},{\"userid\":\"732768128483033088\",\"amount\":\"212\"},{\"userid\":\"732768128483033089\",\"amount\":\"1\"},{\"userid\":\"732768141510541315\",\"amount\":\"163\"},{\"userid\":\"732768201640083467\",\"amount\":\"12\"},{\"userid\":\"732768442145185794\",\"amount\":\"4\"},{\"userid\":\"732768682684612613\",\"amount\":\"43\"},{\"userid\":\"732768875953799169\",\"amount\":\"3\"},{\"userid\":\"732769129235382273\",\"amount\":\"1\"},{\"userid\":\"732769189423644674\",\"amount\":\"1\"},{\"userid\":\"732769210864926727\",\"amount\":\"130\"},{\"userid\":\"732769356860260353\",\"amount\":\"133\"},{\"userid\":\"732769374023352324\",\"amount\":\"56\"},{\"userid\":\"732769404247506949\",\"amount\":\"5\"},{\"userid\":\"732769610305470466\",\"amount\":\"3496\"},{\"userid\":\"732769610305470472\",\"amount\":\"1\"},{\"userid\":\"732769648918233089\",\"amount\":\"4\"},{\"userid\":\"732769657692717058\",\"amount\":\"15\"},{\"userid\":\"732769859350175746\",\"amount\":\"12\"},{\"userid\":\"732769889532387332\",\"amount\":\"3\"}]}}";
//            JSONObject dataJson = JSONObject.parseObject(data);
//            JSONObject actionMsg = dataJson.getJSONObject("actionMsg");
//            if(actionMsg.containsKey("code")){
//                String code = actionMsg.getString("code");
//                log.error("code:"+code);
//                if("0".equals(code)){
//                    JSONObject dataObject =  dataJson.getJSONObject("data");
//                    if(dataObject.containsKey("data")){
//                        JSONArray dataArray = dataObject.getJSONArray("data");
//
//                        List<EBDataReqDto> insertEbDataReqDtoList = Lists.newArrayList();
//                        List<EBDataReqDto> updateEbDataReqDtoList = Lists.newArrayList();
//
//                        for(int i=0;i<dataArray.size();i++){
//                            JSONObject dataInfo = dataArray.getJSONObject(i);
//                            String userid = dataInfo.getString("userid");
//                            String amount = dataInfo.getString("amount");
//                            if(StringUtils.isNotBlank(userid) && StringUtils.isNotBlank(amount)){
//                                String sql = " select id from "+tablename+" where ry=? and tenant_key=? and delete_type=0 ";
//                                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
//                                SqlParamEntity sqlParamEntity = new SqlParamEntity();
//                                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                                sqlParamEntity.setValue(userid+"");
//                                sqlparam.add(sqlParamEntity);
//
//                                sqlParamEntity = new SqlParamEntity();
//                                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
//                                sqlParamEntity.setValue(tenant_key+"");
//                                sqlparam.add(sqlParamEntity);
//
//                                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
//                                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//                                if(!recordList.isEmpty()){
//
//                                    log.error("getChatGroup--!isEmpty");
//                                    String id = String.valueOf(recordList.get(0).get("id"));
//                                    log.error("id:"+id);
//                                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
//                                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
//                                    // 设置更新id
//                                    mainData.add(new EBDataReqDetailDto("id", id));
//                                    mainData.add(new EBDataReqDetailDto(field_amount, amount));
//                                    ebDataReqDto.setMainDatas(mainData);
//                                    updateEbDataReqDtoList.add(ebDataReqDto);
//
//                                }else{
//                                    log.error("getChatGroup--isEmpty");
//
//                                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
//                                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
//                                    mainData.add(new EBDataReqDetailDto(field_ry, userid));
//                                    mainData.add(new EBDataReqDetailDto(field_amount, amount));
//                                    ebDataReqDto.setMainDatas(mainData);
//                                    insertEbDataReqDtoList.add(ebDataReqDto);
//                                }
//                            }
//                        }
//
//                        log.error("getChatDay-insertEbDataReqDtoList:"+insertEbDataReqDtoList.size());
//                        if(insertEbDataReqDtoList !=null && insertEbDataReqDtoList.size()>0){
//                            jucailinPortalUtils.saveModeData(objId,employeeId+"",tenant_key,insertEbDataReqDtoList);
//                        }
//
//                        log.error("getChatDay-updateEbDataReqDtoList:"+updateEbDataReqDtoList.size());
//                        if(updateEbDataReqDtoList !=null && updateEbDataReqDtoList.size()>0){
//                            jucailinPortalUtils.updateModeDataById(objId,employeeId+"",tenant_key,updateEbDataReqDtoList,false);
//                        }
//
//                    }
//                }
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi8:"+e);
//        }
//        return WeaResult.success(dataMap);
//    }

//    @GetMapping("/testSapi9")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi9(HttpServletRequest request){
//
//        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
//
//        log.error("testSapi9");
//        String groupId = "weaver-ebuilder-form-service";
//        String sourceType = "LOGIC";
//        SimpleEmployee employee = UserContext.getCurrentUser();
//        Long cid = employee.getCid();
//        long employeeId = employee.getEmployeeId();
//
////        String field_ry = "985461236726857729" ;
////        String field_amount = "985461236726857730";
////        String objId = "985461167965437954";
//
//        String pkey = "uf_nj_pjmrdlhhsl.ry";
//        String field_ry =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);
//
//        pkey = "uf_nj_pjmrdlhhsl.amount";
//        String field_amount = jucailinPortalUtils.getUfPropData(pkey,tenant_key);
//
//        pkey = "uf_nj_pjmrdlhhsl.objId";
//        String objId = jucailinPortalUtils.getUfPropData(pkey,tenant_key);
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi9");
//        String tablename = "uf_nj_pjmrdlhhsl" ;
//        try {
//            String data = "{\"actionMsg\":{\"code\":0,\"message\":\"成功\",\"traceId\":\"1712572288230237829\"},\"data\":{\"count\":11200,\"data\":[{\"userid\":\"100001840000000001\",\"amount\":\"15478\"},{\"userid\":\"732740550661120001\",\"amount\":\"19\"},{\"userid\":\"732740623600066568\",\"amount\":\"1\"},{\"userid\":\"732740838411632644\",\"amount\":\"1\"},{\"userid\":\"732741031760855045\",\"amount\":\"1\"},{\"userid\":\"732742522042859521\",\"amount\":\"2\"},{\"userid\":\"732742595040526345\",\"amount\":\"1\"},{\"userid\":\"732742672291217409\",\"amount\":\"2\"},{\"userid\":\"732742676670070786\",\"amount\":\"3\"},{\"userid\":\"732742745263718407\",\"amount\":\"1\"}]}}";
//            JSONObject dataJson = JSONObject.parseObject(data);
//            JSONObject actionMsg = dataJson.getJSONObject("actionMsg");
//            if(actionMsg.containsKey("code")){
//                String code = actionMsg.getString("code");
//                log.error("testSapi9-code:"+code);
//                if("0".equals(code)){
//                    JSONObject dataObject =  dataJson.getJSONObject("data");
//                    if(dataObject.containsKey("data")){
//                        JSONArray dataArray = dataObject.getJSONArray("data");
//
//                        List<EBDataReqDto> insertEbDataReqDtoList = Lists.newArrayList();
//                        List<EBDataReqDto> updateEbDataReqDtoList = Lists.newArrayList();
//
//                        for(int i=0;i<dataArray.size();i++){
//                            JSONObject dataInfo = dataArray.getJSONObject(i);
//                            String userid = dataInfo.getString("userid");
//                            String amount = dataInfo.getString("amount");
//                            log.error("userid:"+userid);
//                            log.error("amount:"+amount);
//
//                            if(StringUtils.isNotBlank(userid) && StringUtils.isNotBlank(amount)){
//                                String sql = " select id from "+tablename+" where ry='"+userid+"' and tenant_key='"+tenant_key+"' and delete_type=0 ";
//                                log.error("sql:"+sql);
//
//                                Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
//                                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
//                                if(!recordList.isEmpty()){
//                                    log.error("getChatDay--!isEmpty");
//                                    String id = String.valueOf(recordList.get(0).get("id"));
//                                    log.error("id:"+id);
//                                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
//                                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
//                                    // 设置更新id
//                                    mainData.add(new EBDataReqDetailDto("id", id));
//                                    mainData.add(new EBDataReqDetailDto(field_amount, amount));
//                                    ebDataReqDto.setMainDatas(mainData);
//                                    updateEbDataReqDtoList.add(ebDataReqDto);
//
//                                }else{
//                                    log.error("getChatDay--isEmpty");
//
//                                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
//                                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
//                                    mainData.add(new EBDataReqDetailDto(field_ry, userid));
//                                    mainData.add(new EBDataReqDetailDto(field_amount, amount));
//                                    ebDataReqDto.setMainDatas(mainData);
//                                    insertEbDataReqDtoList.add(ebDataReqDto);
//                                }
//
//                            }
//                        }
//
//                        log.error("getChatDay-insertEbDataReqDtoList:"+insertEbDataReqDtoList.size());
//                        if(insertEbDataReqDtoList !=null && insertEbDataReqDtoList.size()>0){
//                            jucailinPortalUtils.saveModeData(objId,employeeId+"",tenant_key,insertEbDataReqDtoList);
//                        }
//
//                        log.error("getChatDay-updateEbDataReqDtoList:"+updateEbDataReqDtoList.size());
//                        if(updateEbDataReqDtoList !=null && updateEbDataReqDtoList.size()>0){
//                            jucailinPortalUtils.updateModeDataById(objId,employeeId+"",tenant_key,updateEbDataReqDtoList,false);
//                        }
//
//                    }
//                }
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi9:"+e);
//        }
//        return WeaResult.success(dataMap);
//    }


    @GetMapping("/testSapi115")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi115(HttpServletRequest request){
        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi115");
        try {
            String tablename = "uf_nj_cyqltjb" ;
            dataMap.put("tablename",tablename);
            String pagesize = request.getParameter("pagesize");
            String pagenum = request.getParameter("pagenum");

            dataMap.put("tenant_key",tenant_key);
            dataMap.put("pagesize",pagesize);
            dataMap.put("pagesize",pagesize);

            Map<String,Object> dMap = chatGroupUtils.getChatGroup(tenant_key,tablename,pagesize,pagenum);
            dataMap.putAll(dMap);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi14:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }


    @GetMapping("/testSapi116")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi116(HttpServletRequest request){
        //com.weaver.workrelate.performance.api.rest.RemotePerformanceService#queryFlowData
        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi116");
        try {

            String pagesize = request.getParameter("pagesize");
            String pagenum = request.getParameter("pagenum");
            String startDate = request.getParameter("startDate");

            dataMap.put("tenant_key",tenant_key);
            dataMap.put("pagesize",pagesize);
            dataMap.put("pagesize",pagesize);

            String tablename = "uf_nj_pjmrdlhhsl" ;
            dataMap.put("tablename",tablename);
            Map<String,Object> dMap = chatDayUtils.getChatDay(tenant_key,tablename,pagesize,pagenum,startDate);
            dataMap.putAll(dMap);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi14:"+e);
            dataMap.put("count","-1");
        }
        return WeaResult.success(dataMap);
    }


    @GetMapping("/testSapi88")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi88(HttpServletRequest request){

//        String field_ry = "985460777098248194" ;
//        String field_amount = "985460777098248195";
//        String objId = "985460643895541762";

        String pkey = "uf_nj_cyqltjb.ry";
        String field_ry =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_nj_cyqltjb.amount";
        String field_amount = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_nj_cyqltjb.objId";
        String objId = jucailinPortalUtils.getUfPropData(pkey,tenant_key);


        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";
        SimpleEmployee employee = UserContext.getCurrentUser();
        long employeeId = employee.getEmployeeId();

        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi88");
        String tablename = "uf_nj_cyqltjb" ;
        try {


            List<EBDataReqDto> insertEbDataReqDtoList = Lists.newArrayList();
            List<EBDataReqDto> updateEbDataReqDtoList = Lists.newArrayList();

            String userid = request.getParameter("userid");
            String amount = request.getParameter("amount");

            if(StringUtils.isNotBlank(userid) && StringUtils.isNotBlank(amount)){
                String sql = " select id from "+tablename+" where ry=? and tenant_key=? and delete_type=0 ";
                List<SqlParamEntity> sqlparam = new ArrayList<SqlParamEntity>();
                SqlParamEntity sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                sqlParamEntity.setValue(userid+"");
                sqlparam.add(sqlParamEntity);

                sqlParamEntity = new SqlParamEntity();
                sqlParamEntity.setParamType(SqlParamType.VARCHAR);
                sqlParamEntity.setValue(tenant_key+"");
                sqlparam.add(sqlParamEntity);

                Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(!recordList.isEmpty()){

                    log.error("getChatGroup--!isEmpty");
                    String id = String.valueOf(recordList.get(0).get("id"));
                    log.error("id:"+id);
                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
                    // 设置更新id
                    mainData.add(new EBDataReqDetailDto("id", id));
                    mainData.add(new EBDataReqDetailDto(field_amount, amount));
                    ebDataReqDto.setMainDatas(mainData);
                    updateEbDataReqDtoList.add(ebDataReqDto);

                }else{
                    log.error("getChatGroup--isEmpty");

                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
                    mainData.add(new EBDataReqDetailDto(field_ry, userid));
                    mainData.add(new EBDataReqDetailDto(field_amount, amount));
                    ebDataReqDto.setMainDatas(mainData);
                    insertEbDataReqDtoList.add(ebDataReqDto);
                }
            }

            log.error("getChatDay-insertEbDataReqDtoList:"+insertEbDataReqDtoList.size());
            if(insertEbDataReqDtoList !=null && insertEbDataReqDtoList.size()>0){
                jucailinPortalUtils.saveModeData(objId,employeeId+"",tenant_key,insertEbDataReqDtoList);
            }

            log.error("getChatDay-updateEbDataReqDtoList:"+updateEbDataReqDtoList.size());
            if(updateEbDataReqDtoList !=null && updateEbDataReqDtoList.size()>0){
                jucailinPortalUtils.updateModeDataById(objId,employeeId+"",tenant_key,updateEbDataReqDtoList,false);
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi8:"+e);
        }
        return WeaResult.success(dataMap);
    }

    @GetMapping("/testSapi99")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> testSapi99(HttpServletRequest request){

        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";
        SimpleEmployee employee = UserContext.getCurrentUser();
        long employeeId = employee.getEmployeeId();

        String pkey = "uf_nj_pjmrdlhhsl.ry";
        String field_ry =  jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_nj_pjmrdlhhsl.amount";
        String field_amount = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        pkey = "uf_nj_pjmrdlhhsl.objId";
        String objId = jucailinPortalUtils.getUfPropData(pkey,tenant_key);

        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","testSapi9");
        String tablename = "uf_nj_pjmrdlhhsl" ;
        try {

            List<EBDataReqDto> insertEbDataReqDtoList = Lists.newArrayList();
            List<EBDataReqDto> updateEbDataReqDtoList = Lists.newArrayList();

            String userid = request.getParameter("userid");
            String amount = request.getParameter("amount");
            log.error("userid:"+userid);
            log.error("amount:"+amount);

            if(StringUtils.isNotBlank(userid) && StringUtils.isNotBlank(amount)){
                String sql = " select id from "+tablename+" where ry='"+userid+"' and tenant_key='"+tenant_key+"' and delete_type=0 ";
                log.error("sql:"+sql);

                Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
                List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
                if(!recordList.isEmpty()){
                    log.error("getChatDay--!isEmpty");
                    String id = String.valueOf(recordList.get(0).get("id"));
                    log.error("id:"+id);
                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
                    // 设置更新id
                    mainData.add(new EBDataReqDetailDto("id", id));
                    mainData.add(new EBDataReqDetailDto(field_amount, amount));
                    ebDataReqDto.setMainDatas(mainData);
                    updateEbDataReqDtoList.add(ebDataReqDto);

                }else{
                    log.error("getChatDay--isEmpty");

                    EBDataReqDto ebDataReqDto = new EBDataReqDto();
                    List<EBDataReqDetailDto> mainData = Lists.newArrayList();
                    mainData.add(new EBDataReqDetailDto(field_ry, userid));
                    mainData.add(new EBDataReqDetailDto(field_amount, amount));
                    ebDataReqDto.setMainDatas(mainData);
                    insertEbDataReqDtoList.add(ebDataReqDto);
                }
            }

            log.error("getChatDay-insertEbDataReqDtoList:"+insertEbDataReqDtoList.size());
            if(insertEbDataReqDtoList !=null && insertEbDataReqDtoList.size()>0){
                jucailinPortalUtils.saveModeData(objId,employeeId+"",tenant_key,insertEbDataReqDtoList);
            }

            log.error("getChatDay-updateEbDataReqDtoList:"+updateEbDataReqDtoList.size());
            if(updateEbDataReqDtoList !=null && updateEbDataReqDtoList.size()>0){
                jucailinPortalUtils.updateModeDataById(objId,employeeId+"",tenant_key,updateEbDataReqDtoList,false);
            }
        } catch (Exception e) {
            e.printStackTrace();
            log.error("testSapi9:"+e);
        }
        return WeaResult.success(dataMap);
    }


//    @GetMapping("/testSapi188")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> testSapi188(HttpServletRequest request){
//
//        String groupId = "weaver-ebuilder-form-service";
//        String sourceType = "LOGIC";
//
//        String code1 = "";
//        String code2 = "" ;
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","testSapi188");
//        try {
//            String sql = " update uf_nj_cyqltjb set delete_type = 1,is_delete=1 where tenant_key='"+tenant_key+"' and delete_type=0 ";
//            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
//            Iterator<Map.Entry<String, Object>> iterator2 = result.entrySet().iterator();
//            while (iterator2.hasNext()){
//                Map.Entry<String, Object> next = iterator2.next();
//                log.error("insertCustomServiceData--key="+next.getKey()+"  value="+String.valueOf(next.getValue()));
//            }
//            if(result.containsKey("code")){
//                code1 = String.valueOf(result.get("code"));
//            }
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi8:"+e);
//        }
//
//        try {
//            String sql = " update uf_nj_pjmrdlhhsl set delete_type = 1,is_delete=1 where tenant_key='"+tenant_key+"' and delete_type=0 ";
//            Map<String, Object> result = databaseUtils.execute(sourceType, groupId, sql);
//            Iterator<Map.Entry<String, Object>> iterator2 = result.entrySet().iterator();
//            while (iterator2.hasNext()){
//                Map.Entry<String, Object> next = iterator2.next();
//                log.error("insertCustomServiceData--key="+next.getKey()+"  value="+String.valueOf(next.getValue()));
//            }
//            if(result.containsKey("code")){
//                code2 = String.valueOf(result.get("code"));
//            }
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("testSapi8:"+e);
//        }
//
//        dataMap.put("code1",code1);
//        dataMap.put("code2",code2);
//
//        return WeaResult.success(dataMap);
//    }


//    @GetMapping("/test200")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> test200(HttpServletRequest request){
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","test200");
//        try {
//            String objid = request.getParameter("objid");
//            if(StringUtils.isNotBlank(objid)) {
//                Long obj_id = Long.valueOf(objid);
//                WeaResult<Obj> list = remoteEBObjService.getObjInfo(obj_id,tenant_key);
//                dataMap.put("datas",list);
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("test200:"+e);
//            dataMap.put("message",e.getMessage());
//        }
//
//        return WeaResult.success(dataMap);
//    }
//
//
//    @GetMapping("/test201")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> test201(HttpServletRequest request){
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","test201");
//        String columnnames = request.getParameter("columnnames");
//        String objid = request.getParameter("objid");
//        log.error("objid:"+objid);
//        try {
//            if(StringUtils.isNotBlank(objid)){
//                Long obj_id = Long.valueOf(objid);
//                List<Obj> fieldlist = remoteEBObjService.getAllTablesByMasterId(obj_id,tenant_key);
//                dataMap.put("datas",fieldlist);
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("test201:"+e);
//            dataMap.put("message",e.getMessage());
//        }
//        return WeaResult.success(dataMap);
//    }


//    @GetMapping("/test202")
//    @WeaPermission(publicPermission = true)
//    public WeaResult<Object> test202(HttpServletRequest request){
//
//        Map<String,Object> dataMap = new HashMap<String,Object>();
//        dataMap.put("test","test202");
//        try {
//            String TenantKey = TenantRpcContext.getTenantKey();
//            dataMap.put("TenantKey",TenantKey);
//            String appIds = request.getParameter("appIds");
//            List<Obj> list = IEtFormDatasetService.getTables(appIds);
//            dataMap.put("datas",list);
//        } catch (Exception e) {
//            e.printStackTrace();
//            log.error("test202:"+e);
//            dataMap.put("message",e.getMessage());
//        }
//        return WeaResult.success(dataMap);
//    }


    @GetMapping("/test203")
    @WeaPermission(publicPermission = true)
    public WeaResult<Object> test203(HttpServletRequest request){

        Map<String,Object> dataMap = new HashMap<String,Object>();
        dataMap.put("test","test203");
        try {

            SimpleEmployee simpleEmployee = UserContext.getCurrentUser();
            long employeeId = simpleEmployee.getEmployeeId();

            Map<String, Object> map = new HashMap<String, Object>(100);

            log.error("getUserInfo-employeeId:"+employeeId);
            String userimageurl = "/profile/" + employeeId + "/personal";
            String username = String.valueOf(simpleEmployee.getName());
            log.error("username:"+username);

            String department = "";
            String position = "";
            String days = "";
            String doccreate = "0";
            String wfcreate = "0";
            String wfdeal = "0";
            String cyqlsl = "0";
            String mtgtrs = "0";

            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

            try {
                Date hiredate = simpleEmployee.getHiredate();
                log.error("hiredate:"+hiredate.toString());
                Long startDate = hiredate.getTime();
                log.error("startDate:"+startDate);
            }catch (Exception e){
                e.printStackTrace();
                log.error("hiredate-e:"+e);
            }


            try {
                Date hiredate = simpleEmployee.getHiredate();
                log.error("hiredate:"+hiredate.toString());
                Long startDate = hiredate.getTime();
                log.error("startDate:"+startDate);
                Date hire_date = new Date(startDate);
                String entryDate = sdf.format(hire_date);
                log.error("entryDate:"+entryDate);
                if (StringUtils.isNotBlank(entryDate)) {
                    try {
                        days = userInfoCmd.calculateMinute2(entryDate);
                    } catch (Exception e) {
                        log.error("calculateMinute2-e:" + e);
                    }
                    if (StringUtils.isBlank(days)) {
                        days = String.valueOf(userInfoCmd.calculateMinute(entryDate));
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
                log.error("hiredate-e:"+e);
            }


            try {
                department = simpleEmployee.getDepartment().getName();
                log.error("department:"+department);
                position = simpleEmployee.getPosition().getName();
                log.error("position:"+position);
                if (StringUtils.isNotBlank(employeeId+"")) {
                    //文档创建
                    doccreate = userInfoCmd.getDocCreateNum(employeeId);
                    log.error("doccreate:"+doccreate);
                    //流程创建
                    wfcreate = userInfoCmd.getWfCreateNum(simpleEmployee);
                    log.error("wfcreate:"+wfcreate);
                    //流程处理
                    wfdeal = userInfoCmd.getWfDealNum(simpleEmployee);
                    log.error("wfdeal:"+wfdeal);

                    //参与群聊数量
                    cyqlsl = userInfoCmd.getCyqlNumNew(employeeId);
                    log.error("cyqlsl:"+cyqlsl);

                    mtgtrs = userInfoCmd.getPjMtgtcsNew(employeeId);
                    log.error("mtgtrs:"+mtgtrs);
                }
            } catch (Exception e) {
                e.printStackTrace();
                log.error("getUserInfo--Exception:" + e);
            }

            map.put("userid", employeeId+"");
            map.put("userimageurl", userimageurl);
            map.put("username", username);
            map.put("department", department);
            map.put("position", position);
            map.put("days", days);
            map.put("doccreate", doccreate);
            map.put("wfcreate", wfcreate);
            map.put("wfdeal", wfdeal);
            map.put("cyqlsl", cyqlsl);
            map.put("mtgtrs", mtgtrs);
            dataMap.put("datas",map);

        } catch (Exception e) {
            e.printStackTrace();
            log.error("test202:"+e);
            dataMap.put("message",e.getMessage());
        }
        return WeaResult.success(dataMap);
    }


}
